' Restore/Synchronize Database
'
' Version: 3.1.8
' Date: 2019-11-22
' Author: Zvezdan Dimitrijevic
' URL: http://solair.eunet.rs/~zvezdand/RestorePlayHistory.htm
'
' Description:
' This script is for use with MediaMonkey (www.mediamonkey.com) v3.0 or higher.
' It restores playing history (the Played table and Playcount + LastTimePlayed
' fields in the Songs table), playlists (auto-playlists and/or static ones
' in Playlists and PlaylistSongs tables) and/or specified fields in the Songs
' table (e.g. Artist, Title or DateAdded) from some backup database file.
' It could restore data for all tracks in the current database or just filtered.
' or selected ones. The requirement is that Path fields or track checksums or
' FileName.ext/FileLength/Album/Year/TrackNumber fields or
' FileName/SongLength/Artist/Album/Year/TrackNumber fields
' are same in the backup and the current database files.
'
' For discussion about this script you could visit the MediaMonkey forum:
' http://www.mediamonkey.com/forum/viewtopic.php?f=2&t=42085
'
' Installation:
' - For MediaMonley 3.0 or higher, double click on MMIP file.
'
' Legal Notice:
' This add-on is donationware and may not be distributed or sold for profit.
' You are free to use it for the purpose mentioned in the Description section.
' No part of the included software may be redistributed for any purpose without
' the author's consent. Commercial use of this software is not allowed without
' written permission of the author.
'
' This add-on is developed by me, the author, in my own free time. I am not
' employed by Ventis Media, the company behind MediaMonkey, nor I've been paid
' by them for this add-on. So, if you find it useful and/or want to help its
' further development, it would be nice if you send me some small donation
' using PayPal or direct bank transfer. You could donate as much as you think
' that is appropriate, any amount would be really appreciated.
' http://solair.eunet.rs/~zvezdand/Donate.htm

' Disclaimer:
' This software is provided 'as-is', without any express or implied warranty.
' In no event will the author be held liable for any damages arising from the
' use of this software.
'
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit:Const cd="3.1.8",a0="http://solair.eunet.rs/~zvezdand/RestorePlayHistory.htm",t="RestorePlayHistory",cs=4,d5=3,cx=2,bn=True,cy="...",e9=600:Dim be:If sdb.veRSIoNhI>3 Then be="file":Else be="track":End If:Function cw():Dim cz,b0,bj:If am Then On Error Resume Next:If Len(c1)>0 Then cw=sdb.dAtaBaSE.OPeNsqL("SELECT ID FROM Filters WHERE Name = '"&cq(c1)&"'").VALuEbyINDEX(0):cw=sdB.DATaBasE.GeTfilTERQuERy(cw):Else cw="":End If:If Err Then cw="":Else If Len(cw)>0 Then cw=" ("&cw&")":End If:End If:On Error GoTo 0:Else If bi Then Set cz=sDB.selectEdSoNglIsT:For bj=0 To sdb.sEleCTedSOnGLISt.Count-1:Set b0=cz.Item(bj):cw=cw&", "&b0.Id:Next:If Len(cw)Then cw=" Songs.ID IN ("&Mid(cw,3)&")":Else cw=" 0":End If:Else cw="":End If:End If:End Function:Sub da(z):e2=z.chEcKEd:End Sub:Sub bv(z):Dim cv:If dk Then Exit Sub:End If:dk=True:am=z.CheCkEd:Set cv=sdb.OBjECTS("frmRstrDbase").COMmoN.chIldCONTrol("btn_Import"):If am And bi Then al.CHECkEd=False:End If:d9.cOmmON.enABled=am:b:If ds Then If cv.CoMmOn.EnAbLed Then aa.Caption=SdB.LOcAlize("Comparing databases"&cy):Else aa.caPtion=SdB.LocAliZe("Comparing databases..."):End If:SdB.PRoCESSMESSaGes:ef:End If:dk=False:End Sub:Sub Install():Dim e:On Error Resume Next:Set e=sdB.tOoLS.InifILeByPaTh(sdB.sCRipTsiNIFIlE):If Err Then Set e=Sdb.tOoLs.iNIfilebYpAth(sDB.aPpLIcaTIOnpATh&"Scripts\Scripts.ini"):End If:If Not e Is Nothing Then With e:.StrIngVALUE(t,"Filename")="RestorePlayHistory.vbs":.sTrIngvALue(t,"Procname")="RestoreDialog":.strINgValUe(t,"Order")="90":.STRiNGvalue(t,"DisplayName")=sDb.LoCAlIzE("Restore/Synchronize Database")&"...":.STrinGvaLUE(t,"Description")=sdb.lOCaLiZe("Import/export playhistory/playlists/filters/metadata from/to external database"):.STRiNgvAlUE(t,"Language")="VBScript":.STrinGVaLue(t,"ScriptType")="0":End With:SDB.reFreSHsCRIPtitEms:End If:On Error GoTo 0:If Len(SdB.inifILE.STrINgvaLUE(t,"RestorePlaystats"))=0 Then sDB.INiFiLE.boOlvaLUE(t,"RestorePlaystats")=True:End If:If Len(SDb.inifILe.StrInGvalue(t,"ExtraMatchTests"))=0 Then sDb.iNifilE.IntValuE(t,"ExtraMatchTests")=4:End If:End Sub:Sub e1(z):bi=z.cHEcKeD:If bi And am Then cf.cHecKed=False:Else bv cf:End If:End Sub:Sub b():Dim c5,cv,a,bj:c9=False:If Not m Then a=r.Keys:For bj=0 To r.Count-1:If r.Item(a(bj))Then c9=True:Exit For:End If:Next:End If:With SDB.OBjEcts("frmRstrDbase").CommON:Set c5=.cHILDcOntRoL("btn_Export"):Set cv=.ChILdCoNTRoL("btn_Import"):End With:If Not ds Or m And Not e5 Or Not ea And Not e5 And Not bo And((Not bl And Not dm Or Not c9 And Not af)Or x=0)Then c5.coMmon.EnabLeD=False:cv.coMmOn.ENaBLEd=False:Else c5.cOMmON.ENaBled=True:cv.cOmMon.ENAbLEd=True:End If:End Sub:Sub bc(z):bl=z.CheCKeD:b7.common.EnaBlED=bl:b:End Sub:Function dl(dd,dt):Dim cc,ac,a1,c,s,o,a,co,bj:Set cc=CreateObject("Scripting.Dictionary"):Set ac=CreateObject("Scripting.Dictionary"):Set a1=CreateObject("Scripting.Dictionary"):Set c=sdB.dATaBase.opeNsqL("SELECT IDPlaylist, PlaylistName, ParentPlaylist FROM "&dd&"Playlists"):Do While Not c.eoF:s=c.sTrINgBYIndEx(0):cc.AdD CStr(s),c.STringbYiNDEx(1):ac.aDd CStr(s),c.StrInGByinDEx(2):c.Next:Loop:Set c=Nothing:a=cc.KeYs:For bj=0 To cc.Count-1:s=a(bj):co=cc.Item(s):o=ac.Item(s):Do While o>0:If cc.exiSTS(CStr(o))Then co=cc.Item(CStr(o))&Chr(1)&co:o=ac.Item(CStr(o)):Else co="":Exit Do:End If:Loop:If Len(co)Then If dt Then If Not a1.ExIsTS(co)Then a1.add co,s:End If:Else If Not a1.exIsts(CStr(s))Then a1.ADD CStr(s),co:End If:End If:End If:Next:Set dl=a1:End Function:Sub ah(z):at=z.cHECKeD:End Sub:Sub ca(z):ad=z.cHECked:End Sub:Function cq(cu):cq=Replace(cu,"'","''"):End Function:Sub e6(v,cj,n,f,l,dc):Dim y:y="INSERT INTO "&n&"Artists (Artist, Comment, Tracks, Albums, Authors, Conducts":If l Then y=y&", Products, Roles":End If:y=y&", Lyrics) SELECT DISTINCT Artist, Comment, 0, 0, 0, 0":If l Then y=y&", 0, 0":End If:y=y&", 0 FROM "&v&"Artists AS SrcArtists INNER JOIN "&v&"ArtistsSongs AS SrcArtistsSongs ON SrcArtists.ID = SrcArtistsSongs.IDArtist INNER JOIN DBSync ON SrcArtistsSongs.IDSong = "&cj&" WHERE Artist NOT IN (SELECT Artist FROM "&n&"Artists) AND IfNull(PersonType, 1) = "&dc:If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:SDB.daTabase.eXECSQl y:y="INSERT INTO "&n&"ArtistsSongs (PersonType, IDArtist, IDSong) SELECT "&dc&", DstArtists.ID, "&f&" FROM "&n&"Artists AS DstArtists INNER JOIN "&v&"Artists AS SrcArtists ON DstArtists.Artist = SrcArtists.Artist INNER JOIN "&v&"ArtistsSongs AS SrcArtistsSongs ON SrcArtists.ID = SrcArtistsSongs.IDArtist INNER JOIN DBSync ON SrcArtistsSongs.IDSong = "&cj&" WHERE DstArtists.ID || ',' || "&f&" NOT IN (SELECT IDArtist || ',' || IDSong FROM "&n&"ArtistsSongs WHERE IfNull(PersonType, 1) = "&dc&") AND IfNull(SrcArtistsSongs.PersonType, 1) = "&dc:If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:sDb.daTaBaSe.eXECsqL y:y="DELETE FROM "&n&"Artists WHERE ID IN (SELECT IDArtist FROM "&n&"ArtistsSongs AS DstArtistsSongs INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsSongs.IDArtist = DstArtists.ID WHERE IDSong || ',' || IDArtist NOT IN (SELECT DstArtistsSongs.IDSong || ',' || DstArtistsSongs.IDArtist FROM "&n&"ArtistsSongs AS DstArtistsSongs INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsSongs.IDArtist = DstArtists.ID INNER JOIN DBSync ON DstArtistsSongs.IDSong = "&f&" INNER JOIN "&v&"ArtistsSongs AS SrcArtistsSongs ON SrcArtistsSongs.IDSong = "&cj&" INNER JOIN "&v&"Artists AS SrcArtists ON SrcArtistsSongs.IDArtist = SrcArtists.ID WHERE DstArtists.Artist = SrcArtists.Artist AND IfNull(SrcArtistsSongs.PersonType, 1) = "&dc&" AND IfNull(DstArtistsSongs.PersonType, 1) = "&dc&") AND IfNull(PersonType, 1) = "&dc&" AND IDSong IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&") GROUP BY IDArtist HAVING Count(*) >= ":Select Case dc:Case 1:y=y&"Tracks":Case 3:y=y&"Authors":Case 4:y=y&"Conducts":Case 5:y=y&"Lyrics":Case 6:y=y&"Products":Case 7:y=y&"Roles":End Select:y=y&") AND (Albums | ":Select Case dc:Case 1:y=y&"Authors | Conducts | Lyrics":If l Then y=y&" | Products | Roles":End If:Case 3:y=y&"Tracks | Conducts | Lyrics":If l Then y=y&" | Products | Roles":End If:Case 4:y=y&"Tracks | Authors | Lyrics":If l Then y=y&" | Products | Roles":End If:Case 5:y=y&"Tracks | Authors | Conducts":If l Then y=y&" | Products | Roles":End If:Case 6:y=y&"Tracks | Authors | Conducts | Lyrics | Roles":Case 7:y=y&"Tracks | Authors | Conducts | Lyrics | Products":End Select:y=y&") = 0":SDb.databASE.exECsql y:y="DELETE FROM "&n&"ArtistsSongs WHERE IDSong || ',' || IDArtist NOT IN (SELECT DstArtistsSongs.IDSong || ',' || DstArtistsSongs.IDArtist FROM "&n&"ArtistsSongs AS DstArtistsSongs INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsSongs.IDArtist = DstArtists.ID INNER JOIN DBSync ON DstArtistsSongs.IDSong = "&f&" INNER JOIN "&v&"ArtistsSongs AS SrcArtistsSongs ON SrcArtistsSongs.IDSong = "&cj&" INNER JOIN "&v&"Artists AS SrcArtists ON SrcArtistsSongs.IDArtist = SrcArtists.ID WHERE DstArtists.Artist = SrcArtists.Artist AND IfNull(SrcArtistsSongs.PersonType, 1) = "&dc&" AND IfNull(DstArtistsSongs.PersonType, 1) = "&dc&") AND IfNull(PersonType, 1) = "&dc&" AND IDSong IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SdB.dATAbaSe.eXEcsql y:End Sub:Sub e0(z):r.Item(z.commON.CoNtRolnaME)=z.CHeCkeD:If Not dk Then b:End If:End Sub:Function dz(cm):Const c7=2,eb=1:Dim d0:Set d0=CreateObject("ADODB.Stream"):d0.Type=c7:d0.ChaRSet="UTF-8":d0.OpEn:d0.wriTeText cm:d0.PoSiTion=0:d0.Type=eb:d0.POSiTiON=3:dz=d0.reaD:End Function:Sub d3(v,cj,n,f,d6):Dim y:y="DELETE FROM "&n&"ListsSongs WHERE IDSong || ',' || IDList NOT IN (SELECT DstListsSongs.IDSong || ',' || DstListsSongs.IDList FROM "&n&"ListsSongs AS DstListsSongs INNER JOIN "&n&"Lists AS DstLists ON DstListsSongs.IDList = DstLists.ID INNER JOIN DBSync ON DstListsSongs.IDSong = "&f&" INNER JOIN "&v&"ListsSongs AS SrcListsSongs ON SrcListsSongs.IDSong = "&cj&" INNER JOIN "&v&"Lists AS SrcLists ON SrcListsSongs.IDList = SrcLists.ID WHERE DstLists.TextData = SrcLists.TextData AND SrcLists.IDListType = "&d6&" AND DstLists.IDListType = "&d6&") AND IDListType = "&d6&" AND IDSong IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SDb.dAtABAse.ExEcsQl y:y="INSERT INTO "&n&"Lists (IDListType, TextData, SortOrder) SELECT "&d6&", TextData, CASE WHEN SortOrder NOT IN (SELECT SortOrder FROM "&n&"Lists WHERE IDListType = "&d6&") THEN SortOrder ELSE -1 END FROM "&v&"Lists AS SrcLists INNER JOIN "&v&"ListsSongs AS SrcListsSongs ON SrcListsSongs.IDList = SrcLists.ID INNER JOIN DBSync ON IDSong = "&cj&" WHERE TextData NOT IN (SELECT TextData FROM "&n&"Lists WHERE IDListType = "&d6&") AND SrcLists.IDListType = "&d6:If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:y=y&" GROUP BY TextData ORDER BY SortOrder":SDb.dATaBASe.eXecSqL y:y="UPDATE "&n&"Lists SET SortOrder = IfNull((SELECT Max(SortOrder) FROM "&n&"Lists WHERE IDListType = "&d6&"), -1) + 1 + ID - (SELECT Min(ID) FROM "&n&"Lists WHERE IDListType = "&d6&" AND SortOrder = -1) WHERE IDListType = "&d6&" AND SortOrder = -1":sDb.DATaBAsE.EXEcSql y:y="INSERT INTO "&n&"ListsSongs (IDSong, IDListType, IDList) SELECT "&f&", "&d6&", DstLists.ID FROM "&n&"Lists AS DstLists INNER JOIN "&v&"Lists AS SrcLists ON DstLists.TextData = SrcLists.TextData AND DstLists.IDListType = SrcLists.IDListType INNER JOIN "&v&"ListsSongs AS SrcListsSongs ON SrcListsSongs.IDList = SrcLists.ID INNER JOIN DBSync ON SrcListsSongs.IDSong = "&cj&" WHERE DstLists.ID || ',' || "&f&" NOT IN (SELECT IDList || ',' || IDSong FROM "&n&"ListsSongs WHERE IDListType = "&d6&") AND DstLists.IDListType = "&d6:If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:Sdb.daTaBASe.ExECsqL y:End Sub:Sub ec():Dim bu:With SDb.CoMMoNDialOg:.DefaULtExT="db":.Filter="DB files (*.db)|*.db|All files (*.*)|*.*":.FlaGs=cDlOFNHIdeREaDOnLY:If Len(a5)Then bu=a5:Else bu=sDB.iNIfilE.STringvalue(t,"BackupPath"):End If:On Error Resume Next:.IniTdIr=Left(bu,InStrRev(bu,"\")):.fIlenAME=bu:On Error GoTo 0:.title=Sdb.LoCALiZe("Select backup database file"):.SHowoPEN:If Not .Ok Then Exit Sub:End If:a5=.fiLenAmE:End With:cb.tExt=a5:End Sub:Dim cb,dx,cf,d9,al,dh,b7,ba,a6,bx,ch,bb,bm,dn,d2,aa,a5,ds,m,am,bi,bl,e7,ea,e5,ad,bo,e2,af,dm,c9,at,r,p,c1,dk,w,dr,du,d7,ab,ae,b3,c3,x,bw,db,ck,av,bp,b9,ap,a7,ee,an:Set an=CreateObject("Scripting.Dictionary"):With an:.ADd"Title","SongTitle":.add"Artist","Artist":.ADD"Album","Album":.add"AlbumArtist","AlbumArtist":.add"Composer","Author":.adD"Conductor","Conductor":.add"Lyricist","Lyricist":.AdD"InvolvedPeople","InvolvedPeople":.ADd"Date","Year":.aDD"Genre","Genre":.AdD"Rating","Rating":.adD"TrackNumber","TrackNumber":.AdD"DiscNumber","DiscNumber":.ADD"Comment","Comment":.Add"Lyrics","Lyrics":.ADD"Custom1","Custom1":.ADd"Custom2","Custom2":.Add"Custom3","Custom3":.adD"Custom4","Custom4":.adD"Custom5","Custom5":.aDd"Tempo","Tempo":.aDD"Mood","Mood":.aDD"Occasion","Occasion":.ADd"Quality","Quality":.ADd"BPM","BPM":.ADD"OrigArtist","OrigArtist":.adD"OrigTitle","OrigTitle":.ADD"OrigDate","OrigYear":.ADD"OrigLyricist","OrigLyricist":.ADd"Grouping","GroupDesc":.ADD"Copyright","Copyright":.AdD"Encoder","Encoder":.aDd"ISRC","ISRC":.ADD"Publisher","Publisher":If sdb.VERsIONHi>=4 Then .AdD"Actor","Actors":.aDD"Producer","Producer":.Add"SeasonNumber","SeasonNumber":.adD"EpisodeNumber","EpisodeNumber":.ADd"ParentalRating","ParentalRating":.aDD"PlaybackPos","PlaybackPos":.ADd"StartTime","StartTime":.ADd"StopTime","StopTime":.ADd"SkipCount","SkipCount":.Add"Type","TrackType":End If:End With:Sub dw(z):If z.ItEMINDEx>-1 Then c1=z.iTeMtExT(z.iteMIndex):Else c1="":End If:If ds Then aa.cAPtiON=sdb.loCALiZe("Comparing databases"&cy):sDb.pROCEssmEsSaGeS:ef:End If:End Sub:Sub RestoreDialog():Dim u,z,a3,c5,cv,aq,k,di,dp,a9,e,y,c,b2,cz,b0,cg,b6,v,n,cj,f,dv,ax,bt,aj,e8,bq,c8,d,l,ar,bh,bz,cc,ac,d4,bs,ct,ag,bk,g,a,co,o,s,de,cl,c2,b1,c4,dj,ai,ao,a8,aw,h,df,d8,bj,ce:On Error Resume Next:If sDB.dAtabASe.oPeNsqL("SELECT Count(*) FROM Songs").valueByInDeX(0)=0 Then If Sdb.VERsIONHi>=4 Then k="media ":Else k="audio ":End If:SDB.MessAgEBOX"Your database is empty. There are no records about "&k&be&"s in it,"&vbCr&"so you cannot restore/synchronize any data with the external (backup) database."&vbCr&vbCr&"This version of the add-on cannot import records about "&be&"s from the backup"&vbCr&"into the active database, but only their data (metadata, playlists, play history...)."&vbCr&"However, you need to have matched "&be&"s between the active and backup databases"&vbCr&"to be able to import/export their data."&vbCr&vbCr&"Before you start this add-on, you have to add/rescan "&be&"s to the Library (Ins),"&vbCr&"or you could put a backup database file (MM.DB) that you made before into the folder:"&vbCr&Left(Sdb.dAtabaSE.PAth,InStrRev(sdB.dATABasE.PATH,"\")),MtINfORMatiOn,Array(mBoK):Exit Sub:End If:On Error GoTo 0:Set e=SdB.iNIFilE:Set u=SdB.uI.nEWfOrm:With u:.boRDerstYlE=d5:With .COmMoN:di=.WIDTh-.CLIEntwIDTH:dp=.HEIGHt-.clieNtheiGHt:.SETrect 100,100,479+di,ak(Sdb.versiOnHI>=4,503,453)+dp:End With:.FormPosiTioN=cs:.CaptIoN=Sdb.locALIZe("Restore/Synchronize Database"):End With:Set sdB.OBjEcts("frmRstrDbase")=u:Set z=SdB.Ui.NewlabEL(u):With z:.AlIGNmENT=1:With .COmmoN:.AncHOrS=2+4:.sEtrECt u.CoMmOn.cliEntWidtH-100,0,100,20:On Error Resume Next:.fOnTColOR=&hFF0000:.FoNtuNDerline=True:On Error GoTo 0:.CursOrType=-21:.HiNT=a0:End With:sCRIPT.REGIsteReVENt .coMMon,"OnClick","dq":.CAPTion="v"&cd&" ":End With:Set z=Sdb.UI.NeWLaBEl(u):z.commON.SEtrect 10,18,100,20:z.cAPTiOn=sDb.LOcaLIze("Backup database file:"):Set cb=sdb.uI.NewEdIt(u):cb.CoMmon.SEtrEcT 120,15,329,21:ScriPt.rEgiSTeReVent cb,"OnChange","b4":Set dx=SDb.ui.neWBuTton(u):With dx:.CommON.SETrEct 449,15,21,21:.caPTION="...":End With:SCRIpt.rEGIsTeREvENt dx,"OnClick","ec":bz=False:If sdB.vERsioNHi>=4 Then If sDB.veRSIOnbuILd>=1359 Then bz=True:End If:End If:k="Restore playhistory/metadata only for ":If bz Then k=k&be&"s in collection:":Else k=k&"filtered "&be&"s:":End If:Set cf=SDB.uI.newcheCkboX(u):With cf:.coMMON.sEtReCt 10,40,300,20:.Caption=sDb.LOCALiZe(k):SCRIPt.regisTerevENt .CoMMOn,"OnClick","bv":End With:Set d9=SdB.uI.neWdRoPdowN(u):With d9:.StyLE=cx:.cOMMOn.seTreCt 315,39,155,21:End With:scRipt.reGISteREVEnt d9,"OnSelect","dw":Set al=SdB.ui.newCHecKbOX(u):With al:.cOMMOn.SETRect 10,65,450,20:.cApTiOn=Sdb.lOCALizEDforMAT("Restore playhistory/metadata only for %d selected "&be&ak(sdb.SeLecTedSOnGLiSt.Count>1,"s",""),SDb.sELeCTedSoNgLiST.Count,0,0):sCRipT.regiStEREVenT .cOMMoN,"OnClick","e1":End With:Set z=sDb.ui.nEWPanel(u):z.COmMon.SeTREcT 10,89,460,2:Set dh=SDB.ui.neWCHeCKBoX(u):With dh:.COMMon.SetrEcT 10,95,140,20:.CApTIOn=SdB.Localize("Restore playhistory"):scriPt.ReGIsTerEvENT .cOMmOn,"OnClick","bc":End With:e7=e.BOoLvaLUE(t,"ClearPlaystatsFirst"):Set b7=SDb.ui.newcHeckbOX(u):With b7:.coMMOn.SeTRECT 160,95,310,20:.CApTiOn=SDb.loCALizE("Clear Played table && Playcount/LastTimePlayed fields first"):SCRIPt.rEGIsTEreVENT .CoMMON,"OnClick","bf":If e7 Then b7.CheCKed=True:End If:End With:Set z=sDb.Ui.NewpANel(u):z.comMoN.SeTrEcT 10,119,460,2:Set z=sDB.ui.nEWlABEL(u):z.ComMON.SETrECT 10,128,40,20:z.caPtion=SDB.loCalIzE("Restore:"):Set ba=sdb.UI.NeWChEcKBox(u):With ba:.CommoN.sEtReCt 62,125,88,20:.CaptiON=SDB.LOcaLizE("Static playlists"):sCRiPT.rEGisterEvEnT .COmmOn,"OnClick","c0":End With:Set a6=SDb.ui.NeWcHEcKBOx(u):With a6:.COmmOn.SETrecT 160,125,85,20:.cAPtiOn=SdB.LOcAlIZE("AutoPlaylists"):ScRipT.REgisteREVeNt .cOmMoN,"OnClick","ci":End With:ad=e.BoOlvAlUE(t,"ClearPlaylistsFirst"):Set bx=sdB.Ui.newcheCKBOX(u):With bx:.CoMmoN.seTreCT 255,125,215,20:.captiON=sDb.LoCAlIze("Clear Playlists && PlaylistSongs tables first"):scRiPt.ReGistEReVEnT .cOmMOn,"OnClick","ca":If ad Then .cHECKeD=True:End If:End With:Set z=SDb.UI.NEWPaNeL(u):z.coMmON.SeTrEcT 10,149,460,2:Set ch=sDB.ui.newChEcKbOX(u):With ch:.COmmON.SETreCT 10,155,140,20:k="Restore ":If bz Then k=k&"collections":Else k=k&"filters":End If:.CAPTIOn=SdB.lOCALiZe(k&"/views"):ScriPt.REgIstEREvent .COMMon,"OnClick","b5":End With:e2=e.BoOlVALuE(t,"ClearFiltersFirst"):Set bb=SDB.UI.NEwCheCkbOx(u):With bb:.COmMON.SETReCT 160,155,310,20:.CAPTION=sdB.locaLIzE("Clear Filters table first (also Views && NodeViews for MM4 db)"):SCRIpT.reGISteREVeNT .CoMMOn,"OnClick","da":If e2 Then .chECkED=True:End If:End With:Set z=sdb.UI.nEwPaNeL(u):z.Common.SEtrEct 10,179,460,2:a=an.KeyS:Set r=CreateObject("Scripting.Dictionary"):For bj=0 To an.Count-1:r.ADd"ctr"&a(bj),False:Next:dk=True:Set bm=sDB.ui.newchEcKboX(u):With bm:.COMmON.setrECT 10,185,235,20:.CAPtIoN=sDb.locAlIze("Restore metadata in Songs && other tables:"):SCrIPT.REgISTErEVenT .CoMmoN,"OnClick","dg":End With:Set dn=sdb.Ui.NeWcHeCkBox(u):With dn:.comMon.sETRECt 255,185,255,20:.captiOn=sDB.LocAliZE("Update tags in files too (only on Import)"):scRiPt.reGISteREvEnt .coMMoN,"OnClick","ah":.cHECKEd=e.BOolvaLUe(t,"UpdateTagsInFiles"):End With:Set z=SdB.Ui.NEwChEcKBOx(u):With z:With .commoN:.SETreCT 25,210,82,20:.cONTroLNAME="ctrTitle":End With:.CapTiOn=SDb.LoCaliZE("Title"):sCrIPT.ReGIsTereVeNt .CoMMoN,"OnClick","e0":.ChEckEd=e.boOLvAlUE(t,"RestoreTitle"):End With:Set z=sDB.ui.nEWcHECKBoX(u):With z:With .COmmon:.SEtrEcT 115,210,82,20:.ContRoLNAmE="ctrArtist":End With:If sdB.vERSiONHI>=4 Then .caPtION=sdB.LOcAlize("Artist/Direct."):Else .CaPTION=SdB.locALize("Artist"):End If:ScRipT.RegiSterevenT .CommOn,"OnClick","e0":.chECkEd=e.BoOLValUE(t,"RestoreArtist"):End With:Set z=SDB.ui.NeWcHECKBOx(u):With z:With .ComMoN:.sEtrect 205,210,82,20:.ControlnAME="ctrAlbum":End With:If sdB.VErSIONHI>=4 Then .CAPTIoN=sdb.lOCaliZE("Album/Series"):Else .CAPTiOn="Album":End If:SCRiPt.regISTErEVeNT .COmMoN,"OnClick","e0":.CHeCkED=e.bOOLvAluE(t,"RestoreAlbum"):End With:Set z=SDb.Ui.NEwCheCkbox(u):With z:With .CommOn:.seTrECt 295,210,82,20:.CONtrolNAme="ctrAlbumArtist":End With:.caPtION="Album Artist":ScrIpt.RegISteREVent .coMmoN,"OnClick","e0":.cHeckeD=e.boolVALuE(t,"RestoreAlbumArtist"):End With:Set z=SDb.Ui.newcHeckBox(u):With z:With .CoMmON:.SeTreCT 385,210,82,20:.CoNTroLName="ctrComposer":End With:.CaPTIon="Composer":ScRiPt.rEgisterEvenT .COmmoN,"OnClick","e0":.chECkEd=e.BoOlvAlue(t,"RestoreComposer"):End With:Set z=sdB.ui.neWchecKbOX(u):With z:With .comMOn:.seTReCt 25,235,82,20:.cOnTRolnaMe="ctrConductor":End With:.CaptioN="Conductor":sCriPt.rEgIstEReVEnT .coMmOn,"OnClick","e0":.CHECKeD=e.BooLValUe(t,"RestoreConductor"):End With:Set z=SDB.ui.NeWCheCkbox(u):With z:With .COMMoN:.SETreCT 115,235,84,20:.cOnTrOLnAmE="ctrLyricist":End With:If SDb.VERsionHI>=4 Then .cAPTIOn=Sdb.LOcALIZE("Lyricist/Scr.w."):Else .CApTION="Lyricist":End If:scrIpT.ReGiSterEVenT .coMmon,"OnClick","e0":.Checked=e.BOoLVAluE(t,"RestoreLyricist"):End With:Set z=sdb.UI.neWCHECKBoX(u):With z:With .CommOn:.SETrecT 205,235,82,20:.COnTROLnAMe="ctrInvolvedPeople":End With:.captioN="Invol. People":sCRipT.rEgisTeREvenT .coMMoN,"OnClick","e0":.CHEcKED=e.BoolvaLuE(t,"RestoreInvolvedPeople"):End With:Set z=sDb.ui.NeWcHeCkBOx(u):With z:With .COMMon:.Setrect 295,235,82,20:.ConTROlNaMe="ctrDate":End With:.cAPtIon="Date":sCripT.ReGISTereVENT .cOmMOn,"OnClick","e0":.checkeD=e.bOOlValUE(t,"RestoreDate"):End With:Set z=sdB.ui.NeWCHEcKbox(u):With z:With .CoMMoN:.setReCT 385,235,82,20:.cONTROLNaME="ctrGenre":End With:.CAptIon="Genre":scripT.rEgIsTeREVEnT .COMMON,"OnClick","e0":.CHEcKEd=e.boOLVALue(t,"RestoreGenre"):End With:Set z=sDb.UI.NEWCHeCKBoX(u):With z:With .coMmoN:.sETrECT 25,260,82,20:.cONtrolname="ctrRating":End With:.CAPTIon="Rating":SCrIPT.ReGIsTereVENT .cOMMoN,"OnClick","e0":.chECked=e.booLvALuE(t,"RestoreRating"):End With:Set z=SDB.Ui.nEwCHEckBOX(u):With z:With .comMON:.SeTRect 115,260,82,20:.CONTRolname="ctrTrackNumber":End With:.CAptION="Track #":sCRIPt.REGIStEReVent .COmMoN,"OnClick","e0":.cHEckeD=e.boolvalUE(t,"RestoreTrackNumber"):End With:Set z=sdb.UI.newchEcKbox(u):With z:With .COmMOn:.setREct 205,260,82,20:.conTrOLNaME="ctrDiscNumber":End With:.cAPtiON="Disc #":sCrIPt.ReGIstErEVEnt .coMmON,"OnClick","e0":.cHecKED=e.BoOlvaLue(t,"RestoreDiscNumber"):End With:Set z=sdb.ui.NewcHECkboX(u):With z:With .comMON:.SeTreCt 295,260,82,20:.CONTRolNaME="ctrComment":End With:.cApTioN="Comment":SCRIpt.RegistErEveNt .CoMMOn,"OnClick","e0":.cHECkEd=e.BoolValue(t,"RestoreComment"):End With:Set z=sDb.uI.newCHECKbOx(u):With z:With .cOmmoN:.SEtREct 385,260,82,20:.COnTROlnamE="ctrLyrics":End With:.cAptIoN="Lyrics":sCRIpt.ReGIStEREVEnt .comMon,"OnClick","e0":.cheCkED=e.BOolvALUe(t,"RestoreLyrics"):End With:Set z=sdB.ui.nEWCheckbOX(u):With z:With .coMMON:.SEtREct 25,285,82,20:.cOnTrOLnAme="ctrCustom1":End With:.cAPtIoN=e.stRINgVAlUE("CustomFields","Fld1Name"):scripT.regIstereVeNT .comMoN,"OnClick","e0":.CHEcKED=e.booLVAlue(t,"RestoreCustom1"):End With:Set z=SDb.UI.nEwcheCKBOx(u):With z:With .coMMoN:.seTrect 115,285,82,20:.contROlNAME="ctrCustom2":End With:.CAPtiON=e.STrInGValue("CustomFields","Fld2Name"):ScRipT.rEgiSTeREVEnt .cOmMOn,"OnClick","e0":.CHEcKed=e.BOOlvalue(t,"RestoreCustom2"):End With:Set z=sDb.UI.NEwCHecKBoX(u):With z:With .COMMoN:.seTrecT 205,285,82,20:.COntrOLnamE="ctrCustom3":End With:.CaptIoN=e.sTRiNgvaLuE("CustomFields","Fld3Name"):scRipT.RegisTeREVEnT .common,"OnClick","e0":.ChECkED=e.BoolvalUE(t,"RestoreCustom3"):End With:Set z=SDb.Ui.NEWcHEckBox(u):With z:With .cOMMoN:.sEtReCt 295,285,82,20:.coNtrOlNaME="ctrCustom4":End With:.CaptiOn=e.StRINgValue("CustomFields","Fld4Name"):ScRIpt.REGIsteReVeNt .cOmmoN,"OnClick","e0":.cheCKEd=e.BOolvaLuE(t,"RestoreCustom4"):End With:Set z=SDB.Ui.NEWCheCkBoX(u):With z:With .cOMMON:.SetrEct 385,285,82,20:.conTroLNaMe="ctrCustom5":End With:.CaPtion=e.StRINGVAlue("CustomFields","Fld5Name"):sCRipt.ReGiSTErEvenT .COMmON,"OnClick","e0":.cHeCKED=e.boOLVAlUE(t,"RestoreCustom5"):End With:Set z=SdB.uI.nEWCHeckBOX(u):With z:With .CoMmoN:.seTreCT 25,310,82,20:.contrOLnAme="ctrTempo":End With:.cAPtIOn="Tempo":sCript.regIsTEREvENt .cOmmoN,"OnClick","e0":.ChEckEd=e.bOOlValuE(t,"RestoreTempo"):End With:Set z=sDB.ui.NewcheCkboX(u):With z:With .coMMON:.sEtrEct 115,310,82,20:.COntrOLNAmE="ctrMood":End With:.cApTIoN="Mood":scRIpT.regisTeRevenT .comMoN,"OnClick","e0":.cHeCKEd=e.boOLVAlue(t,"RestoreMood"):End With:Set z=SDb.Ui.neWChECkboX(u):With z:With .CommON:.SeTrECt 205,310,82,20:.cOnTRolnAMe="ctrOccasion":End With:.captIon="Occasion":script.REGiSTEREVENt .COmMOn,"OnClick","e0":.cheCkeD=e.bOolVAlUe(t,"RestoreOccasion"):End With:Set z=SdB.ui.NeWChEckbox(u):With z:With .COMMOn:.sETRECT 295,310,82,20:.COntrOLNAMe="ctrQuality":End With:.captiON="Quality":ScRiPT.rEGiStErEveNt .COMmON,"OnClick","e0":.cheCKed=e.boOlvalUE(t,"RestoreQuality"):End With:Set z=sDB.uI.nEWChEckBox(u):With z:With .commOn:.SEtrecT 385,310,82,20:.CONtROlnamE="ctrBPM":End With:.cAPtiON="BPM":scRIPt.rEGIsTeReVent .cOmMon,"OnClick","e0":.cHeckEd=e.boolvalUe(t,"RestoreBPM"):End With:Set z=SDb.ui.NeWcHeckbOX(u):With z:With .COmmoN:.SEtrEcT 25,335,82,20:.cOntrOLNAME="ctrOrigArtist":End With:.CAPtioN="Orig. Artist":sCRIpt.reGiSTEreVent .CommoN,"OnClick","e0":.chEckeD=e.BoolvALuE(t,"RestoreOrigArtist"):End With:Set z=sdb.UI.nEwcHEckboX(u):With z:With .ComMon:.SeTRECt 115,335,82,20:.conTROLName="ctrOrigTitle":End With:.caPTIon="Original Title":scriPt.reGIstEREVent .COmmoN,"OnClick","e0":.cHEckED=e.bOoLVAlue(t,"RestoreOrigTitle"):End With:Set z=sDb.uI.nEWcHECKbOX(u):With z:With .cOmMon:.sETREct 205,335,82,20:.coNTrOlNAME="ctrOrigDate":End With:.CAPtIon="Original Date":scRIPT.reGISTeReVENt .CoMmON,"OnClick","e0":.cheCKed=e.bOolvaLuE(t,"RestoreOrigDate"):End With:Set z=sDB.UI.neWCHeCKboX(u):With z:With .coMMoN:.SETRect 295,335,82,20:.cONtrOLName="ctrOrigLyricist":End With:.caPtIon="Orig. Lyricist":sCript.ReGIsterEVEnt .CoMMON,"OnClick","e0":.CHEcKED=e.BoolvAlUe(t,"RestoreOrigLyricist"):End With:Set z=SDb.UI.neWcHecKBoX(u):With z:With .coMmOn:.SEtrect 385,335,82,20:.coNTRolnaMe="ctrGrouping":End With:.CAPTIon="Grouping":SCrIpt.ReGIStEREVENT .cOmMON,"OnClick","e0":.cHecKED=e.bOOLVaLUe(t,"RestoreGrouping"):End With:Set z=SDb.Ui.NEwCHeckBoX(u):With z:With .CommoN:.SeTReCt 25,360,82,20:.contrOLNamE="ctrCopyright":End With:.CAptioN="Copyright":ScrIPt.REgIsTerEvent .cOMMON,"OnClick","e0":.CHECKEd=e.bOoLVAlUe(t,"RestoreCopyright"):End With:Set z=SDB.UI.NEwchECkBOx(u):With z:With .COmmON:.sETREcT 115,360,82,20:.ConTrOlnAME="ctrEncoder":End With:.capTIoN="Encoder":sCriPt.REGIStEreVEnT .cOmmon,"OnClick","e0":.cHECKED=e.BoOLvalUe(t,"RestoreEncoder"):End With:Set z=Sdb.Ui.nEwCHEcKboX(u):With z:With .coMMon:.SeTREct 205,360,82,20:.COnTRoLnaME="ctrISRC":End With:.cAPtION="ISRC":scrIpt.reGiSTEreVENt .ComMon,"OnClick","e0":.CHECkEd=e.bOOlvALue(t,"RestoreISRC"):End With:Set z=sdb.UI.NeWchecKbOx(u):With z:With .cOmMOn:.SETRecT 295,360,82,20:.CONTrolNAME="ctrPublisher":End With:.CApTIon="Publisher":ScRipt.regIstEReveNT .cOmMON,"OnClick","e0":.CheCKed=e.bOOlVALuE(t,"RestorePublisher"):End With:Set d2=SdB.Ui.nEWCHEckbOx(u):With d2:.CoMMON.seTREct 385,360,82,20:.cAptION="Date Added":scrIpt.rEGISTEReVeNt .ComMoN,"OnClick","az":.cHEcKEd=e.BOOLvaLue(t,"RestoreDateAdded"):End With:If SDb.vErsioNhi>=4 Then Set z=sDb.UI.NEWChEckbox(u):With z:With .cOMMoN:.SetRect 25,385,82,20:.cOnTrOlnaMe="ctrActor":End With:.CaptiON="Actor(s)":SCripT.REGiSTErEVeNt .CoMmoN,"OnClick","e0":.chEckeD=e.BoolvalUe(t,"RestoreActor"):End With:Set z=SDb.ui.NEWCheCkbOx(u):With z:With .COMmon:.SEtrecT 115,385,82,20:.CONTroLnAME="ctrProducer":End With:.capTiON="Producer":ScrIpt.rEGIsTereveNt .CoMMON,"OnClick","e0":.checKED=e.BooLVaLUE(t,"RestoreProducer"):End With:Set z=SDb.uI.NewcheCKBOX(u):With z:With .COmMon:.sETrect 205,385,82,20:.CONTrOLname="ctrSeasonNumber":End With:.cAPTIoN="Season #":ScRIpT.RegiSteREVENT .COMmOn,"OnClick","e0":.CHeCked=e.BoolvaLuE(t,"RestoreSeasonNumber"):End With:Set z=sdB.UI.NEwcHeckbOx(u):With z:With .commON:.sEtREcT 295,385,82,20:.coNtrOlname="ctrEpisodeNumber":End With:.caPtION="Episode #":sCriPT.regIsTErEvEnt .commoN,"OnClick","e0":.ChecKEd=e.BOOLvalUe(t,"RestoreEpisodeNumber"):End With:Set z=SdB.ui.nEWchEcKBOX(u):With z:With .COMmON:.setReCt 385,385,83,20:.cOnTrolNAmE="ctrParentalRating":End With:.cAPTiOn="Paren. Rating":SCRIPT.RegISTerEvENT .cOmMON,"OnClick","e0":.cHECKED=e.boOlValUE(t,"RestoreParentalRating"):End With:Set z=SDb.UI.NeWcheckbox(u):With z:With .commOn:.SetReCt 25,410,82,20:.COnTROlNAmE="ctrPlaybackPos":End With:.CApTIon="Bookmark":scrIpt.ReGISTeREvEnt .cOmmoN,"OnClick","e0":.CheCkEd=e.booLVAlUE(t,"RestorePlaybackPos"):End With:Set z=SdB.uI.NEwcheCkbOx(u):With z:With .cOMMON:.seTreCt 115,410,82,20:.cONtroLNamE="ctrStartTime":End With:.CAPtION="Start Time":Script.rEGISTEreVent .CoMmon,"OnClick","e0":.chECked=e.boOlvAlue(t,"RestoreStartTime"):End With:Set z=sdB.uI.neWCHEcKBOX(u):With z:With .coMmON:.SetReCt 205,410,82,20:.ControLName="ctrStopTime":End With:.CAPTion="Stop Time":SCRipT.REGISTEREVent .cOMmOn,"OnClick","e0":.CheCked=e.bOoLvalUE(t,"RestoreStopTime"):End With:Set z=sdb.UI.nEWcHECkBOx(u):With z:With .COMMoN:.sETrEcT 295,410,82,20:.cONtrOLName="ctrSkipCount":End With:.CAPtIOn="Skipped #":sCRiPt.RegiSTERevENt .CoMMoN,"OnClick","e0":.ChECked=e.BOolvaLuE(t,"RestoreSkipCount"):End With:Set z=sdb.ui.neWCheckBox(u):With z:With .CoMmON:.SETreCt 385,410,83,20:.COntrolnamE="ctrType":End With:.cAptiOn="Type":ScrIpt.rEgIsTEReVeNT .coMMon,"OnClick","e0":.chEcked=e.BoolvalUE(t,"RestoreType"):End With:End If:dk=False:Set z=SDb.Ui.NewPAnel(u):z.coMMON.SeTrect 10,ak(SDb.VeRSIONHI>=4,434,384),460,2:Set aa=sDB.Ui.NEWlABEL(u):With aa:.cOMMon.SetREcT 10,ak(sDb.VersIoNHi>=4,441,391),450,20:.CaPTioN=SdB.LocAlIze("Please specify database file for backup/export/import."):End With:Set z=sdB.uI.neWpanel(u):z.comMON.seTRect 10,ak(sdB.VERsiOnhI>=4,460,410),460,2:Set a3=sdb.UI.nEwbUTToN(u):With a3:With .comMON:.sEtRecT 169,ak(sdB.verSIONhi>=4,470,420),70,25:.coNTROlnAME="btn_Backup":End With:.cApTiOn=SDb.LoCalizE("&Backup"):.Default=True:.mODaLresuLT=1:End With:Set c5=sDB.uI.NEwBUTtOn(u):With c5:With .COMmon:.SetREcT 246,ak(SdB.VErsiOnhi>=4,470,420),70,25:.cOnTrOLnAme="btn_Export":End With:.caPTIOn=SDB.LoCALIze("&Export"):.MODalResuLt=3:End With:Set cv=sDB.UI.NewBuTTon(u):With cv:With .CoMmON:.SETRECT 323,ak(SDb.VeRSionhi>=4,470,420),70,25:.CONTrOLnAme="btn_Import":End With:.CapTioN=SDB.LocAlIzE("&Import"):.MoDAlReSUlt=4:End With:Set aq=Sdb.Ui.NeWBUtTON(u):With aq:.CoMmon.sEtRect 400,ak(sDb.veRsIonhi>=4,470,420),70,25:.caPtIoN=sDb.LOcaLIZE("&Cancel"):.CanCEl=True:.MoDALrESUlT=2:End With:ds=False:Set c=sDB.DAtaBAsE.opeNsqL("PRAGMA database_list"):Do While Not c.eof:If c.sTrINgBYname("name")="BackupDB"Then If a5=c.sTRINgByNAme("file")Then ds=True:Else Set c=Nothing:On Error Resume Next:Sdb.DaTAbASe.FOrcEcOMmit:If Err Then sDB.daTaBasE.CoMMIt:End If:On Error GoTo 0:Sdb.databASE.eXEcSQl"DETACH DATABASE BackupDB":End If:Exit Do:End If:c.Next:Loop:Set c=Nothing:bl=e.bOOlVALUe(t,"RestorePlaystats"):If bl Then dh.cHeckEd=True:Else bc dh:End If:ea=e.booLVaLUE(t,"StaticPlaylists"):If ea Then ba.cheCkED=True:End If:e5=e.BOOlvALuE(t,"AutoPlaylists"):If e5 Then a6.ChECkEd=True:Else ci a6:End If:bo=e.BOOLvAlue(t,"RestoreFilters"):If bo Then ch.cHeCkeD=True:Else b5 ch:End If:dm=e.BoOLvaLuE(t,"RestoreSongsFields"):If dm Then bm.CheCKed=True:Else dg bm:End If:bi=e.bOOlValuE(t,"SelectedTracksOnly"):am=e.BoOlvAluE(t,"FilteredTracksOnly"):c1=e.StrINGvaLue(t,"FilterName"):If Len(c1)=0 Then c1=sdb.DAtaBAsE.OPensQL("SELECT Name FROM Filters WHERE ID = "&sDB.DATabasE.ACTivEFILteRiD).StrInGbYiNdEx(0):End If:Set c=sDB.DatABASe.OPeNsqL("SELECT Name FROM Filters WHERE Name <> '' ORDER BY Pos"):Do While Not c.Eof:d9.aDDIteM c.sTrinGbyIndex(0):If am And c1=c.striNgBYinDEx(0)Then d9.ITeMINdeX=d9.iTEmCounT-1:End If:c.Next:Loop:Set c=Nothing:If bi Then al.cHEcKEd=True:Else If am Then cf.CheckeD=am:Else bv cf:End If:End If:bq=Sdb.datABASE.oPENsQl("PRAGMA temp_store").valuEbyindex(0):SdB.DaTaBasE.EXecSQl"PRAGMA temp_store=MEMORY":If Len(a5)>0 Then a3.COMMon.enAblEd=True:Else a3.Common.enaBLed=False:End If:Set a7=sdB.CReaTeTiMEr(e9*1000):a7.EnabLed=False:scRIpt.REgisTeREvent a7,"OnTimer","a2":If Len(a5)>0 And w Then If sDb.ToOLs.FileSystem.fiLeExISTs(a5)Then y="SELECT Count(*) FROM Songs":Set c=SDB.DAtabaSe.OPenSQL(y):aj=CLng(c.vaLUEbYINdex(0)):If aj Then y="SELECT Max(ID) FROM Songs":Set c=sdb.databAsE.opEnsqL(y):If c.eof Then e8=0:Else If IsNumeric(c.VAluEbyinDex(0))Then e8=CLng(c.ValuEbyiNDeX(0)):Else e8=0:End If:End If:Else e8=0:End If:Set c=Nothing:If db=aj And av=e8 Then On Error Resume Next:If Not ds Then Sdb.dAtabase.eXecsQL"ATTACH DATABASE '"&cq(a5)&"' AS BackupDB":End If:If Err=0 Then ds=True:On Error GoTo 0:y="SELECT InfoValue FROM BackupDB.DBInfo WHERE IDInfo = 10":Set c=sDB.DaTaBASe.oPENsql(y):dv=CLng(c.vaLuEbyINdeX(0)):If dr=dv Then y="SELECT Count(*) FROM BackupDB.Songs":Set c=SDb.daTabASE.opEnsql(y):ax=CLng(c.vAlUEbYINDEX(0)):If ax Then y="SELECT Max(ID) FROM BackupDB.Songs":Set c=sdB.DAtAbASE.OpENsql(y):If c.eof Then bt=0:Else If IsNumeric(c.vAlUEbYiNdex(0))Then bt=CLng(c.VAluebyINdEX(0)):Else bt=0:End If:End If:Else bt=0:End If:Set c=Nothing:If ck=ax And bp=bt Then dk=True:cb.tEXT=a5:dk=False:b:ef:End If:End If:Else On Error GoTo 0:End If:End If:End If:End If:u.SavepOsITIoNNamE=u.cAPTIon:a9=u.showmoDAL:a7.eNAblEd=False:Set ap=Nothing:ScRIPT.UNreGIStErALLEvents:Set sDb.oBjEcTS("frmRstrDbase")=Nothing:If a9=2 Then ed bq,ds:Exit Sub:Else If UCase(a5)=UCase(sdb.dataBaSE.PATH)Then ed bq,ds:Select Case a9:Case 1:k="backup data to":Case 3:k="export data to":Case Else k="import data from":End Select:Sdb.MESsaGEbOx SDB.LOcALIze("You cannot "&k&" the current database file!"),MteRROR,Array(MBok):Exit Sub:Else If Not ds And a9<>1 Then ed bq,ds:Select Case a9:Case 3:k="Export":Case Else k="Import":End Select:Sdb.mesSAgebox k&" cannot be applied since the"&vbCr&"backup database file cannot be attached!",MtERror,Array(Mbok):Exit Sub:Else Select Case a9:Case 1:ed bq,ds:If SDb.tOOLs.FileSystem.FILeExIStS(a5)Then If sdb.MEsSAGEBox("A file with the specified name already exists."&vbCr&"If you continue, the backup will overwrite that file.",mtWArning,Array(MbOk,mbcanCEL))<>MRok Then Exit Sub:End If:End If:sDB.IniFilE.STrINGvalue(t,"BackupPath")=a5:Set cg=CreateObject("Scripting.FileSystemObject"):cg.COPYFILe sDB.datAbASe.patH,a5,True:Exit Sub:Case 3:If m Then ed bq,ds:sDB.mEssaGEBOx"Backup database contains only auto-playlists data."&vbCr&"You cannot export data to that file.",mTWARning,Array(mBOk):Exit Sub:Else If SDB.mESsagEboX("Are you really sure that you want to export"&vbCr&"data to the external (backup) database file?",mtcONfIrMAtIoN,Array(MboK,mBcANCEL))=mrCAnceL Then ed bq,ds:Exit Sub:End If:End If:b6=True:v="":n="BackupDB.":cj="SongsID":f="BackupID":Case Else If SdB.MESSaGEBOX("Are you really sure that you want to import"&vbCr&"data to the current (active) database file?",mtcOnfIRmaTiOn,Array(MboK,mBcANcEl))=mrcANCeL Then ed bq,ds:Exit Sub:End If:b6=False:v="BackupDB.":n="":cj="BackupID":f="SongsID":End Select:End If:End If:End If:If m Then ea=False:End If:With Sdb.INIFiLE:.strInGvaluE(t,"BackupPath")=a5:If Not m Then .boOlvAlUE(t,"FilteredTracksOnly")=am:If am Then .STRingValUe(t,"FilterName")=c1:End If:.BoolvALue(t,"SelectedTracksOnly")=bi:.BoOlvaLue(t,"RestorePlaystats")=bl:.BoolvalUE(t,"ClearPlaystatsFirst")=e7:.bOOlVaLUE(t,"StaticPlaylists")=ea:.booLVAlue(t,"ClearPlaylistsFirst")=ad:.BooLVAlue(t,"RestoreFilters")=bo:.bOoLvALUe(t,"ClearFiltersFirst")=e2:.bOolvAluE(t,"RestoreSongsFields")=dm:.BOOLvAluE(t,"UpdateTagsInFiles")=at:.bOOLVALuE(t,"RestoreDateAdded")=af:a=an.KEys:For bj=0 To an.Count-1:.boOLvAluE(t,"Restore"&a(bj))=r.Item("ctr"&a(bj)):Next:End If:.BOOLVaLUe(t,"AutoPlaylists")=e5:End With:If x=0 And Not m Then ed bq,ds:sdB.meSsAgEbOx sdB.LOcaLIZE("Restore cannot be done without matched "&be&"s."),mtINFoRmAtioN,Array(mbok):Exit Sub:End If:Set ap=sDb.PRogRESs:ee=sDb.cuRSoRtYpE:sDb.CursORtYpE=-11:SDB.pRoCeSsmesSaGes:k="":a8=Now:aw=Timer:df=0:If am Or bi Then p=cw:Else p="":End If:c8=SDb.DatABASE.OpeNsql("PRAGMA cache_size").VAlUebYinDex(0):If CLng(c8)<50000 Then sDB.dATaBAse.execSQl"PRAGMA cache_size=50000":Else c8=0:End If:On Error Resume Next:SDb.dATaBaSE.bEGINTrANSActiON:If Err Then ed bq,ds:If c8>0 Then sDB.daTabase.eXeCSqL"PRAGMA cache_size="&c8:End If:SDB.CURSORTYpe=ee:Set ap=Nothing:SdB.pROCessmeSSaGeS:sdB.MessagEBoX SDb.loCaLiZe(ak(b6,"Ex","Im")&"port cannot be done since the database file is locked."),MTerrOR,Array(MBok):Exit Sub:End If:On Error GoTo 0:If bl And Not m Then ap.texT=SDb.LOCAliZE(ak(b6,"Ex","Im")&"porting play history..."):sdb.CUrSoRTYpe=-11:sdB.ProCessmESsaGeS:d=False:l=False:y="PRAGMA BackupDB.table_info(Played)":Set c=sdb.DATabAse.opEnSql(y):Do While Not c.EoF:If c.sTRiNGBYnAmE("name")="UTCOffset"Then If b6 Then l=True:Else d=True:End If:Exit Do:End If:c.Next:Loop:Set c=Nothing:If sdB.vErsionHi>=4 Then If b6 Then d=True:Else l=True:End If:End If:SDb.DAtabaSe.ExecSQL"DROP TABLE IF EXISTS BackupPlayed":sdB.DATABASE.exeCSqL"CREATE TEMP TABLE BackupPlayed (PlayID INTEGER PRIMARY KEY, PlayCount INTEGER, PlayLast REAL)":If e7 Then y="DELETE FROM "&n&"Played":If x<ak(b6,ck,bw)Then y=y&" WHERE IDSong IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":End If:SDB.dAtaBAsE.ExecSQl y:If SDb.DATaBASE.OpEnSqL("SELECT Count(*) FROM "&n&"Played").VALuEbyINDEX(0)=0 Then y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'Played'":sdb.DATaBasE.eXeCSQL y:End If:y="INSERT INTO "&n&"Played (IDSong, PlayDate":If l And(d Or bn)Then y=y&", UTCOffset":End If:y=y&") SELECT "&f&", ":If l And d Then y=y&"SrcPlayed.PlayDate, SrcPlayed.UTCOffset":Else If l And bn Then y=y&"JulianDay(SrcPlayed.PlayDate + JulianDay('1899-12-30'), 'utc') - JulianDay('1899-12-30'), SrcPlayed.PlayDate - JulianDay(SrcPlayed.PlayDate + JulianDay('1899-12-30'), 'utc') + JulianDay('1899-12-30')":Else If Not l And d And bn Then y=y&" + SrcPlayed.UTCOffset":Else y=y&"SrcPlayed.PlayDate":End If:End If:End If:y=y&" FROM "&v&"Played AS SrcPlayed INNER JOIN DBSync ON "&cj&" = SrcPlayed.IDSong":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&" ORDER BY SrcPlayed.PlayDate":sdB.dAtAbASe.EXECSql y:y="SELECT "&f&" AS PlayID, PlayCounter AS PlayCount, LastTimePlayed AS PlayLast FROM DBSync INNER JOIN "&v&"Songs ON ID = "&cj:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:SDb.DAtABase.eXEcsQL"INSERT INTO BackupPlayed "&y:y="UPDATE "&n&"Songs SET PlayCounter = (SELECT PlayCount FROM BackupPlayed WHERE ID = PlayID), LastTimePlayed = (SELECT ":If(l=d)Or Not bn Then y=y&"PlayLast":Else If l Then y=y&"CASE WHEN PlayLast > 0 THEN JulianDay(PlayLast + JulianDay('1899-12-30'), 'utc') - JulianDay('1899-12-30') ELSE 0 END":Else y=y&"CASE WHEN PlayLast > 0 THEN JulianDay(PlayLast + JulianDay('1899-12-30'), 'localtime') - JulianDay('1899-12-30') ELSE 0 END":End If:End If:y=y&" FROM BackupPlayed WHERE ID = PlayID) WHERE ID IN (SELECT "&f&" FROM DBSync":Else y="INSERT INTO BackupPlayed SELECT "&f&" AS PlayID, ":y=y&"Max(Sum(PlayCounter) - Sum((SELECT Count(*) FROM (SELECT DateTime(PlayDate":If d Then y=y&" + UTCOffset":End If:y=y&") FROM "&v&"Played WHERE IDSong = ID  INTERSECT SELECT DateTime(PlayDate":If l Then y=y&" + UTCOffset":End If:y=y&") FROM "&n&"Played WHERE IDSong = "&f&"))), 0)":y=y&" AS PlayCount, Max(LastTimePlayed) AS PlayLast FROM DBSync INNER JOIN "&v&"Songs ON ID = "&cj:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&" GROUP BY "&f:SdB.DAtabaSe.exECSqL y:y="INSERT INTO "&n&"Played (IDSong, PlayDate":If l And(d Or bn)Then y=y&", UTCOffset":End If:y=y&") SELECT "&f&", ":If l And d Then y=y&"SrcPlayed.PlayDate, SrcPlayed.UTCOffset":Else If l And bn Then y=y&"JulianDay(SrcPlayed.PlayDate + JulianDay('1899-12-30'), 'utc') - JulianDay('1899-12-30'), SrcPlayed.PlayDate - JulianDay(SrcPlayed.PlayDate + JulianDay('1899-12-30'), 'utc') + JulianDay('1899-12-30')":Else If Not l And d And bn Then y=y&" + SrcPlayed.UTCOffset":Else y=y&"SrcPlayed.PlayDate":End If:End If:End If:y=y&" FROM "&v&"Played AS SrcPlayed INNER JOIN DBSync ON "&cj&" = SrcPlayed.IDSong WHERE "&f&" || '|' || DateTime(SrcPlayed.PlayDate":If d Then y=y&" + SrcPlayed.UTCOffset":End If:y=y&") NOT IN (SELECT IDSong || '|' || DateTime(PlayDate":If l Then y=y&" + UTCOffset":End If:y=y&") FROM "&n&"Played)":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:y=y&" ORDER BY SrcPlayed.IDPlayed":SdB.DAtABaSe.eXeCsqL y:y="UPDATE "&n&"Songs SET PlayCounter = IfNull((SELECT PlayCount FROM BackupPlayed WHERE PlayID = ID), 0) + IfNull(PlayCounter, 0), LastTimePlayed = Max(IfNull((SELECT ":If(l=d)Or Not bn Then y=y&"PlayLast":Else If l Then y=y&"CASE WHEN PlayLast > 0 THEN JulianDay(PlayLast + JulianDay('1899-12-30'), 'utc') - JulianDay('1899-12-30') ELSE 0 END":Else y=y&"CASE WHEN PlayLast > 0 THEN JulianDay(PlayLast + JulianDay('1899-12-30'), 'localtime') - JulianDay('1899-12-30') ELSE 0 END":End If:End If:y=y&" FROM BackupPlayed WHERE PlayID = ID), 0.0), IfNull(LastTimePlayed, 0.0)) WHERE ID IN (SELECT "&f&" FROM DBSync":End If:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":sdB.DAtaBaSe.ExecSqL y:sdb.DAtaBase.eXECsql"DROP TABLE IF EXISTS BackupPlayed":h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:k=k&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:End If:If dm And Not m Then d=False:l=False:y="PRAGMA BackupDB.table_info(Artists)":Set c=sdb.DAtaBasE.OpEnSQL(y):Do While Not c.EOF:If c.StrIngbynAmE("name")="Products"Then If b6 Then l=True:Else d=True:End If:Exit Do:End If:c.Next:Loop:Set c=Nothing:If sdb.VersionHI>=4 Then If b6 Then d=True:Else l=True:End If:End If:End If:If dm And af And Not m Then ap.TexT=SDb.lOcAlIze(ak(b6,"Ex","Im")&"porting date added field..."):sDb.cURSORTyPe=-11:SDb.prOCeSsmESSaGeS:If(l=d)Or Not bn Then y="DateAdded":Else If l Then y="JulianDay(DateAdded + JulianDay('1899-12-30'), 'utc') - JulianDay('1899-12-30')":Else y="JulianDay(DateAdded + JulianDay('1899-12-30'), 'localtime') - JulianDay('1899-12-30')":End If:End If:y="UPDATE "&n&"Songs SET DateAdded = IfNull((SELECT "&y&" FROM DBSync INNER JOIN "&v&"Songs AS SrcSongs ON "&cj&" = SrcSongs.ID WHERE "&f&" = Songs.ID), DateAdded) WHERE ID IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SdB.DatabAse.ExecsQl y:End If:If dm And c9 And Not m Then ap.teXT=SdB.loCAlIZe(ak(b6,"Ex","Im")&"porting metadata..."):SdB.cuRsoRType=-11:SDB.prOCeSsMESSagES:If r.Item("ctrGenre")Then y="DELETE FROM "&n&"GenresSongs WHERE IDSong || ',' || IDGenre NOT IN (SELECT DstGenreSongs.IDSong || ',' || DstGenreSongs.IDGenre FROM "&n&"GenresSongs AS DstGenreSongs INNER JOIN "&n&"Genres AS DstGenres ON DstGenreSongs.IDGenre = DstGenres.IDGenre INNER JOIN DBSync ON DstGenreSongs.IDSong = "&f&" INNER JOIN "&v&"GenresSongs AS SrcGenreSongs ON SrcGenreSongs.IDSong = "&cj&" INNER JOIN "&v&"Genres AS SrcGenres ON SrcGenreSongs.IDGenre = SrcGenres.IDGenre WHERE DstGenres.GenreName = SrcGenres.GenreName) AND IDSong IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SDB.DATaBAse.EXECsQl y:y="INSERT INTO "&n&"Genres (GenreName, Description, UsageCount) SELECT DISTINCT GenreName, Description, 0 FROM "&v&"Genres AS SrcGenres INNER JOIN "&v&"GenresSongs AS SrcGenreSongs ON SrcGenres.IDGenre = SrcGenreSongs.IDGenre INNER JOIN DBSync ON IDSong = "&cj&" WHERE GenreName NOT IN (SELECT GenreName FROM "&n&"Genres)":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:sDb.dAtAbAsE.ExecSQl y:y="INSERT INTO "&n&"GenresSongs (IDGenre, IDSong) SELECT DstGenres.IDGenre, "&f&" FROM "&n&"Genres AS DstGenres INNER JOIN "&v&"Genres AS SrcGenres ON DstGenres.GenreName = SrcGenres.GenreName INNER JOIN "&v&"GenresSongs AS SrcGenreSongs ON SrcGenreSongs.IDGenre = SrcGenres.IDGenre INNER JOIN DBSync ON SrcGenreSongs.IDSong = "&cj&" WHERE DstGenres.IDGenre || ',' || "&f&" NOT IN (SELECT IDGenre || ',' || IDSong FROM "&n&"GenresSongs)":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:SDb.DATABaSe.EXeCSqL y:End If:If r.Item("ctrTempo")Then d3 v,cj,n,f,1:End If:If r.Item("ctrMood")Then d3 v,cj,n,f,2:End If:If r.Item("ctrOccasion")Then d3 v,cj,n,f,3:End If:If r.Item("ctrQuality")Then d3 v,cj,n,f,4:End If:If r.Item("ctrArtist")Then e6 v,cj,n,f,l,1:End If:If r.Item("ctrComposer")Then e6 v,cj,n,f,l,3:End If:If r.Item("ctrConductor")Then e6 v,cj,n,f,l,4:End If:If r.Item("ctrLyricist")Then e6 v,cj,n,f,l,5:End If:If d And l Then If r.Item("ctrProducer")Then e6 v,cj,n,f,True,6:End If:If r.Item("ctrActor")Then e6 v,cj,n,f,True,7:End If:End If:If r.Item("ctrAlbumArtist")Then y="INSERT INTO "&n&"Artists (Artist, Comment, Tracks, Albums, Authors, Conducts":If l Then y=y&", Products, Roles":End If:y=y&", Lyrics) SELECT DISTINCT SrcArtists.Artist, SrcArtists.Comment, 0, 0, 0, 0":If l Then y=y&", 0, 0":End If:y=y&", 0 FROM "&v&"Artists AS SrcArtists INNER JOIN "&v&"ArtistsAlbums AS SrcArtistsAlbums ON SrcArtists.ID = SrcArtistsAlbums.IDArtist INNER JOIN "&v&"Songs AS SrcSongs ON SrcArtistsAlbums.IDAlbum = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" WHERE SrcArtists.Artist NOT IN (SELECT Artist FROM "&n&"Artists)":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:sdB.daTaBaSE.EXecSQl y:End If:If r.Item("ctrAlbumArtist")Or r.Item("ctrAlbum")Then y="INSERT INTO "&n&"Albums (Artist, Album, Year, Comment, Tracks) SELECT DISTINCT SrcAlbums.Artist, SrcAlbums.Album, SrcAlbums.Year, SrcAlbums.Comment, 0 FROM "&v&"Albums AS SrcAlbums INNER JOIN "&v&"Songs AS SrcSongs ON SrcAlbums.ID = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" WHERE SrcAlbums.Artist || x'0100' || SrcAlbums.Album NOT IN (SELECT Artist || x'0100' || Album FROM "&n&"Albums)":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:Sdb.daTabASe.exEcSql y:y="INSERT INTO "&n&"ArtistsAlbums (IDArtist, IDAlbum) SELECT DISTINCT DstArtists.ID, DstAlbums.ID FROM "&n&"Artists AS DstArtists INNER JOIN "&v&"Artists AS SrcArtists ON DstArtists.Artist = SrcArtists.Artist INNER JOIN "&v&"ArtistsAlbums AS SrcArtistsAlbums ON SrcArtists.ID = SrcArtistsAlbums.IDArtist INNER JOIN "&v&"Albums AS SrcAlbums ON SrcArtistsAlbums.IDAlbum = SrcAlbums.ID INNER JOIN "&v&"Songs AS SrcSongs ON SrcArtistsAlbums.IDAlbum = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" INNER JOIN "&n&"Albums AS DstAlbums ON SrcAlbums.Album = DstAlbums.Album AND SrcAlbums.Artist = DstAlbums.Artist":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&" EXCEPT SELECT IDArtist, IDAlbum FROM "&n&"ArtistsAlbums":sdB.database.EXecsQl y:End If:If r.Item("ctrAlbumArtist")Then y="DELETE FROM "&n&"Artists WHERE ID IN (SELECT IDArtist FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsAlbums.IDArtist = DstArtists.ID WHERE IDArtist || ',' || IDAlbum NOT IN (SELECT DstArtistsAlbums.IDArtist || ',' || DstAlbums.ID FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsAlbums.IDArtist = DstArtists.ID INNER JOIN "&n&"Albums AS DstAlbums ON DstArtistsAlbums.IDAlbum = DstAlbums.ID INNER JOIN "&v&"Albums AS SrcAlbums ON SrcAlbums.Album = DstAlbums.Album AND SrcAlbums.Artist = DstAlbums.Artist INNER JOIN "&v&"ArtistsAlbums AS SrcArtistsAlbums ON SrcArtistsAlbums.IDAlbum = SrcAlbums.ID INNER JOIN "&v&"Artists AS SrcArtists ON SrcArtistsAlbums.IDArtist = SrcArtists.ID INNER JOIN "&v&"Songs AS SrcSongs ON SrcAlbums.ID = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" WHERE DstArtists.Artist = SrcArtists.Artist":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:y=y&" UNION ALL SELECT DstArtistsAlbums.IDArtist || ',' || DstSongs.IDAlbum FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Songs AS DstSongs ON DstArtistsAlbums.IDAlbum = DstSongs.IDAlbum WHERE DstSongs.ID NOT IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")) GROUP BY IDArtist HAVING Count(*) >= Albums) AND (Tracks | Authors | Conducts | Lyrics":If l Then y=y&" | Products | Roles":End If:y=y&") = 0":SdB.DATAbAsE.Execsql y:End If:If r.Item("ctrAlbumArtist")Or r.Item("ctrAlbum")Then y="DELETE FROM "&n&"ArtistsAlbums WHERE IDArtist || ',' || IDAlbum NOT IN (SELECT DstArtistsAlbums.IDArtist || ',' || DstAlbums.ID FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Artists AS DstArtists ON DstArtistsAlbums.IDArtist = DstArtists.ID INNER JOIN "&n&"Albums AS DstAlbums ON DstArtistsAlbums.IDAlbum = DstAlbums.ID INNER JOIN "&v&"Albums AS SrcAlbums ON SrcAlbums.Album = DstAlbums.Album AND SrcAlbums.Artist = DstAlbums.Artist INNER JOIN "&v&"ArtistsAlbums AS SrcArtistsAlbums ON SrcArtistsAlbums.IDAlbum = SrcAlbums.ID INNER JOIN "&v&"Artists AS SrcArtists ON SrcArtistsAlbums.IDArtist = SrcArtists.ID INNER JOIN "&v&"Songs AS SrcSongs ON SrcAlbums.ID = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" WHERE DstArtists.Artist = SrcArtists.Artist":If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:y=y&" UNION ALL SELECT DstArtistsAlbums.IDArtist || ',' || DstSongs.IDAlbum FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Songs AS DstSongs ON DstArtistsAlbums.IDAlbum = DstSongs.IDAlbum WHERE DstSongs.ID NOT IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&"))":sDb.datABasE.eXECSQl y:y="DELETE FROM "&n&"Albums WHERE ID IN (SELECT DstAlbums.ID FROM "&n&"Albums AS DstAlbums INNER JOIN "&n&"Songs AS DstSongs ON DstAlbums.ID = DstSongs.IDAlbum INNER JOIN DBSync ON DstSongs.ID = "&f:If w And Len(p)>0 Then y=y&" AND Selected = 1":End If:y=y&" EXCEPT SELECT DstAlbums.ID FROM "&n&"ArtistsAlbums AS DstArtistsAlbums INNER JOIN "&n&"Albums AS DstAlbums ON DstArtistsAlbums.IDAlbum = DstAlbums.ID)":sDb.dATaBase.EXeCSQl y:y="UPDATE "&n&"Songs SET IDAlbum = (SELECT DstAlbums.ID FROM "&n&"Albums AS DstAlbums INNER JOIN "&v&"Albums AS SrcAlbums ON SrcAlbums.Album = DstAlbums.Album AND SrcAlbums.Artist = DstAlbums.Artist INNER JOIN "&v&"Songs AS SrcSongs ON SrcAlbums.ID = SrcSongs.IDAlbum INNER JOIN DBSync ON SrcSongs.ID = "&cj&" WHERE "&f&" = "&n&"Songs.ID) WHERE ID IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SdB.DaTabASe.ExECsQl y:y="UPDATE "&n&"Albums SET Tracks = (SELECT Count(*) FROM "&n&"Songs AS DstSongs WHERE DstSongs.IDAlbum = "&n&"Albums.ID) WHERE ID IN (SELECT IDAlbum FROM "&n&"Songs AS DstSongs INNER JOIN DBSync ON DstSongs.ID = "&f:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":sdB.dAtaBasE.eXecSQL y:End If:Set g=CreateObject("Scripting.Dictionary"):Set c=sdB.dATABasE.OPeNsQL("PRAGMA BackupDB.table_info(Songs)"):Do While Not c.EOf:g.adD c.sTrINGbyNamE("name"),"":c.Next:Loop:Set c=Nothing:y="":a=an.Keys:For bj=0 To an.Count-1:If g.exists(an.Item(a(bj)))And r.Item("ctr"&a(bj))Then y=y&", "&an.Item(a(bj))&" = (SELECT SrcSongs."&an.Item(a(bj))&" FROM DBSync INNER JOIN "&v&"Songs AS SrcSongs ON "&cj&" = SrcSongs.ID WHERE "&f&" = "&n&"Songs.ID GROUP BY "&f&")":End If:Next:If Len(y)Then y="UPDATE "&n&"Songs SET "&Mid(y,3)&" WHERE ID IN (SELECT "&f&" FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":SdB.DaTABaSE.ExeCsQL y:End If:End If:If dm And(af Or c9)And Not m Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:k=k&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:End If:Set ct=Nothing:If ea Or e5 Then ap.Text=sDB.loCALIze(ak(b6,"Ex","Im")&"porting playlists..."):SDb.CuRsOrTYpe=-11:Sdb.pRoCEsSMesSages:d=False:l=False:bh="":Set g=CreateObject("Scripting.Dictionary"):y="PRAGMA BackupDB.table_info(Playlists)":Set c=SDB.daTaBASE.OpENsqL(y):Do While Not c.eof:ar=c.STRInGByNAMe("name"):g.adD UCase(ar),"":IF ar="IDFilter"Then If b6 Then l=True:Else d=True:End If:End If:c.Next:Loop:y="PRAGMA table_info(Playlists)":Set c=sDB.DatAbAse.OPeNSQL(y):Do While Not c.EOF:ar=c.strinGBYName("name"):If g.eXIStS(UCase(ar))Then Select Case ar:Case"IDPlaylist","ParentPlaylist":Case Else bh=bh&", "&ar:End Select:End If:IF ar="IDFilter"Then If b6 Then d=True:Else l=True:End If:End If:c.Next:Loop:Set c=Nothing:If ad And ea And e5 And Not m Then cl=0:y="DELETE FROM "&n&"Playlists":sdb.dAtaBAsE.ExEcsqL y:y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'Playlists'":SDB.dAtabAsE.EXeCsQl y:y="INSERT INTO "&n&"Playlists (IDPlaylist, ParentPlaylist"&bh&") SELECT IDPlaylist, ParentPlaylist"&bh&" FROM "&v&"Playlists":Sdb.DATabAse.eXECsQL y:y="DELETE FROM "&n&"PlaylistSongs":SDb.dAtaBAsE.ExecSQl y:y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'PlaylistSongs'":sdB.DataBase.exECSQL y:y="INSERT INTO "&n&"PlaylistSongs (IDPlaylist, IDSong, SongOrder) SELECT SrcPlistSongs.IDPlaylist, "&f&", SrcPlistSongs.SongOrder FROM "&v&"PlaylistSongs AS SrcPlistSongs ":If e.bOolvalUE(t,"PlistAltMethod")And sdb.VErsiOnhi<4 Then y=y&"INNER JOIN DBSync ON SrcPlistSongs.IDSong = "&cj:Else y=y&"LEFT JOIN DBSync ON SrcPlistSongs.IDSong = "&cj&" AND "&f&" IS NOT NULL":End If:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:SDB.datABAse.exECsql y:Set g=CreateObject("Scripting.Dictionary"):bj=0:Set c=SDB.DATaBAsE.opEnSqL("SELECT IDPlaylist, QueryData FROM "&n&"Playlists WHERE IsAutoPlaylist = 1"):Do While Not c.EoF:y=q(c.STriNGByIndEX(1),v,n,Nothing,Nothing):If y<>c.STrINGbYIndEx(1)Then y="UPDATE "&n&"Playlists SET QueryData = '"&cq(y)&"' WHERE IDPlaylist = "&c.STriNgbyiNdeX(0):g.adD CStr(bj),y:bj=bj+1:End If:c.Next:Loop:Set c=Nothing:For bj=0 To g.Count-1:Sdb.DAtabase.EXeCsQL g.Item(CStr(bj)):Next:Else y="SELECT Max(IDPlaylist) FROM "&n&"Playlists":Set c=sDB.DATaBaSe.oPENsql(y):If Not c.eoF Then cl=c.strINgByIndEX(0):Else cl=0:End If:Set c=Nothing:Set ct=dl(n,True):Set cc=CreateObject("Scripting.Dictionary"):Set ac=CreateObject("Scripting.Dictionary"):Set d4=CreateObject("Scripting.Dictionary"):Set bs=CreateObject("Scripting.Dictionary"):Set bk=CreateObject("Scripting.Dictionary"):Set g=CreateObject("Scripting.Dictionary"):Set c=sdb.DaTABASe.OpENSql("SELECT IDPlaylist, PlaylistName, ParentPlaylist, CASE WHEN IsAutoPlaylist IS NULL OR IsAutoPlaylist = '' THEN 0 ELSE IsAutoPlaylist END, CASE WHEN IsAutoPlaylist = 1 THEN QueryData ELSE '' END FROM "&v&"Playlists"):Do While Not c.eOF:s=c.STRiNGbYINDex(0):cc.ADd CStr(s),c.sTriNGbyiNDEx(1):ac.Add CStr(s),c.StriNGbYiNdEX(2):bk.Add CStr(s),c.StRiNGByINdEX(3):If Len(c.stRinGBYinDEx(4))>0 Then g.add CStr(s),c.StRINgBYINDEX(4):End If:c.Next:Loop:Set c=Nothing:a=cc.keyS:For bj=0 To cc.Count-1:s=a(bj):co=cc.Item(s):o=ac.Item(s):de=bk.Item(s):Do While o>0:If cc.EXiSts(CStr(o))Then co=cc.Item(CStr(o))&Chr(1)&co:If de<>bk.Item(CStr(o))Then bk.Item(CStr(o))=-1:de=-1:End If:o=ac.Item(CStr(o)):Else co="":Exit Do:End If:Loop:If Len(co)Then If Not d4.exiSTS(co)Then d4.ADd co,s:bs.ADd CStr(s),co:End If:End If:Next:y="SELECT Max(Max(IDPlaylist), Max(ParentPlaylist)) FROM "&n&"Playlists":Set c=SdB.dATABAse.opENSQL(y):If Not c.eof Then c2=c.STrinGBYiNDeX(0):Else c2=0:End If:Set c=Nothing:c2=c2+d4.Count:Set ag=CreateObject("Scripting.Dictionary"):a=d4.KEYS:For bj=0 To d4.Count-1:co=a(bj):If Not ct.EXiSTS(co)Then s=d4.Item(co):If bk.Item(s)<>0 And e5 Or(bk.Item(s)<>1 And ea Or e5 And ea)And Not m Then y="INSERT INTO "&n&"Playlists (ParentPlaylist"&bh&") SELECT IDPlaylist + "&c2&bh&" FROM "&v&"Playlists WHERE IDPlaylist = "&s:SDb.daTAbase.execSql y:ag.Add CStr(s+c2),co:ct.aDd co,s+c2:End If:End If:Next:If ea And Not m Then y="INSERT INTO "&n&"PlaylistSongs (IDPlaylist, IDSong, SongOrder) SELECT DstPlists.IDPlaylist, "&f&", SrcPlistSongs.SongOrder FROM "&v&"PlaylistSongs AS SrcPlistSongs INNER JOIN "&n&"Playlists AS DstPlists ON DstPlists.ParentPlaylist - "&c2&" = SrcPlistSongs.IDPlaylist ":If e.boOlVALUe(t,"PlistAltMethod")And SDb.VErSIONhI<4 Then y=y&"INNER JOIN DBSync ON SrcPlistSongs.IDSong = "&cj:Else y=y&"LEFT JOIN DBSync ON SrcPlistSongs.IDSong = "&cj&" AND "&f&" IS NOT NULL":End If:If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:SDB.dATaBaSE.EXeCSQL y:End If:Set c=sdb.DATAbASe.oPensql("SELECT IDPlaylist, ParentPlaylist FROM "&n&"Playlists WHERE ParentPlaylist > "&c2):Do While Not c.Eof:s=c.VaLuEbYindEx(1):If ag.EXisTS(CStr(s))Then ct.Item(CStr(ag.Item(CStr(s))))=CStr(c.strINgBYINdeX(0)):End If:c.Next:Loop:Set c=Nothing:a=ag.kEys:For bj=0 To ag.Count-1:s=a(bj):o=s-c2:If g.eXIstS(CStr(o))And Not m Then y=q(g.Item(CStr(o)),v,n,ct,bs):If y<>g.Item(CStr(o))Then y="UPDATE "&n&"Playlists SET QueryData = '"&cq(y)&"' WHERE ParentPlaylist = "&s:SDB.daTABAse.execsql y:End If:End If:If ac.eXISTs(CStr(o))Then o=ac.Item(CStr(o)):If Int(o)=0 Then y="UPDATE "&n&"Playlists SET ParentPlaylist = 0 WHERE ParentPlaylist = "&s:sdB.DataBaSE.eXeCSQl y:Else If bs.exIsts(CStr(o))Then co=bs.Item(CStr(o)):If ct.eXiSTS(co)Then y="UPDATE "&n&"Playlists SET ParentPlaylist = "&ct.Item(co)&" WHERE ParentPlaylist = "&s:sdB.DataBasE.exEcsQl y:End If:End If:End If:End If:Next:End If:If Not b6 And sDb.MaIntReE.node_PLAYLiSts.EXPAnDeD Then SDB.maiNTREE.NoDE_PLAYlisTS.ExpanDeD=False:sDB.mAiNtReE.nodE_pLaYLISts.exPAnDeD=True:End If:h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:k=k&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:End If:If bo And Not m Then ap.TExt=sDB.lOcALize(ak(b6,"Ex","Im")&"porting filters and views..."):sdb.cURsoRtYPE=-11:SdB.ProcEsSMeSsAges:d=False:l=False:y="PRAGMA BackupDB.table_info(Filters)":Set c=SDB.dATabaSe.openSQl(y):Do While Not c.eOF:If c.strInGbynAmE("name")="IDView"Then If b6 Then l=True:Else d=True:End If:Exit Do:End If:c.Next:Loop:Set c=Nothing:If SDb.VErsIONHi>=4 Then If b6 Then d=True:Else l=True:End If:End If:If e2 Then y="DELETE FROM "&n&"Filters":sdb.DAtabASe.ExEcsQL y:y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'Filters'":sdb.DAtabAse.eXecsqL y:If l Then y="DELETE FROM "&n&"Views":sdB.dAtABASE.eXEcsQL y:y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'Views'":SDb.daTabASe.exECsQl y:y="DELETE FROM "&n&"NodeViews":sdb.daTaBase.eXECsQl y:y="DELETE FROM "&n&"sqlite_sequence WHERE name = 'NodeViews'":SDB.DATABase.EXeCSQl y:End If:ai=1:Else y="SELECT Max(Pos) FROM "&n&"Filters":Set c=Sdb.DaTABASE.oPENSql(y):If Not c.EOf Then ai=c.ValuebyINdeX(0)+1:Else ai=1:End If:Set c=Nothing:End If:Set g=CreateObject("Scripting.Dictionary"):y="SELECT Name, Cond FROM "&v&"Filters":If Not e2 Then y=y&" WHERE Name NOT IN (SELECT Name FROM "&n&"Filters)":End If:y=y&" ORDER BY Pos, ID":Set c=SDb.daTaBASe.oPENSQL(y):Do While Not c.EoF:b1=c.STRiNgBYiNdEx(0):If Not g.EXiSTs(b1)Then g.adD b1,c.STRingbYInDex(1):End If:c.Next:Loop:Set c=Nothing:If ct Is Nothing Then Set ct=dl(n,True):Set bs=dl(v,False):End If:If l Then y="INSERT INTO "&n&"Views (Name, View) SELECT ":If d Then y=y&"SrcViews.Name, SrcViews.View FROM "&v&"Views AS SrcViews":If Not e2 Then y=y&" INNER JOIN "&v&"Filters AS SrcFilters ON IDView = SrcViews.ID WHERE SrcFilters.Name NOT IN (SELECT Name FROM "&n&"Filters) AND SrcViews.Name NOT IN (SELECT Name FROM "&n&"Views)":End If:y=y&" GROUP BY SrcViews.Name ORDER BY SrcViews.ID":Else y=y&"Name, View FROM "&v&"Filters AS SrcFilters":If Not e2 Then y=y&" WHERE Name NOT IN (SELECT Name FROM "&n&"Filters) AND Name NOT IN (SELECT Name FROM "&n&"Views)":End If:y=y&" GROUP BY Name ORDER BY SrcFilters.ID":End If:Sdb.datAbasE.eXeCsQl y:End If:a=g.kEyS:For bj=0 To g.Count-1:b1=a(bj):y="SELECT CAST(SubStr(x'"&g.Item(b1)&"', 1, 9999999) AS text)":c4=Sdb.DAtAbAsE.OpeNSQl(y).sTrIngByInDex(0):dj=q(c4,v,n,ct,bs):If c4<>dj Then c4="'":ao=dz(dj):For ce=1 To Lenb(ao):c4=c4&Right("0"& Hex(AscB(MiDB(ao,ce,1))),2):Next:c4=c4&"'":Else c4="Cond":End If:y="INSERT INTO "&n&"Filters (Pos, Name, Cond, ":If l Then y=y&"IDView, Description, VisibleInMainTree, Icon":Else y=y&"View, Player, ContentType":End If:y=y&") SELECT "&ai+bj&", SrcFilters.Name, "&c4&", ":If l And d Then y=y&"DstViews.ID, Description, VisibleInMainTree, Icon":Else If l Then y=y&"DstViews.ID, '', 1, ''":Else If d Then y=y&"SrcViews.View, 0, 0":Else y=y&"View, Player, ContentType":End If:End If:End If:y=y&" FROM "&v&"Filters AS SrcFilters ":If d Then y=y&"INNER JOIN "&v&"Views AS SrcViews ON SrcFilters.IDView = SrcViews.ID ":End If:If l Then y=y&"INNER JOIN "&n&"Views AS DstViews ":If d Then y=y&"ON SrcViews.Name = DstViews.Name ":Else y=y&"ON SrcFilters.Name = DstViews.Name ":End If:End If:y=y&"WHERE SrcFilters.Name = '"&cq(b1)&"' GROUP BY SrcFilters.Name":sdB.databAse.eXeCsql y:Next:If d And l Then If Not e2 Then y="INSERT INTO "&n&"Views (Name, View) SELECT SrcViews.Name, SrcViews.View FROM "&v&"Views AS SrcViews INNER JOIN "&v&"NodeViews AS SrcNodeViews ON IDView = SrcViews.ID WHERE NodeType NOT IN (SELECT NodeType FROM "&n&"NodeViews) AND SrcViews.Name NOT IN (SELECT Name FROM "&n&"Views) GROUP BY SrcViews.Name  ORDER BY SrcViews.ID":Sdb.DATabase.execSQl y:End If:y="INSERT INTO "&n&"NodeViews (NodeType, IDView, DeviceID, ContentType) SELECT NodeType, DstViews.ID, DeviceID, ContentType FROM "&v&"NodeViews INNER JOIN "&v&"Views AS SrcViews ON IDView = SrcViews.ID INNER JOIN "&n&"Views AS DstViews ON SrcViews.Name = DstViews.Name":If Not e2 Then y=y&" WHERE NodeType NOT IN (SELECT NodeType FROM "&n&"NodeViews)":End If:SDb.daTABAsE.exECsqL y:End If:h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:k=k&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:End If:If(ea Or e5)And Not m And bo And d And l Then y="UPDATE "&n&"Playlists SET IDFilter = IfNull((SELECT DstFilters.ID FROM "&n&"Filters AS DstFilters INNER JOIN "&v&"Filters AS SrcFilters ON DstFilters.Name = SrcFilters.Name WHERE SrcFilters.ID = IDFilter), -1) WHERE IDPlaylist > "&cl:sDb.DataBASE.eXeCSql y:End If:ds=False:sDb.DatABAse.CoMmIt:On Error Resume Next:Sdb.DaTabAsE.FORCecOMMIT:On Error GoTo 0:ed bq,ds:If c8>0 Then sDb.daTabAsE.eXEcSql"PRAGMA cache_size="&c8:End If:If Not b6 And Not m Then If dm And c9 And at Then ap.TexT=SDb.LOCAliZE("Writing tags to files..."):SdB.CuRsOrTyPE=-11:SDb.PRoCESsMEssageS:Set cz=SdB.NEwSoNgLiST:y="ID IN (SELECT SongsID FROM DBSync":If w And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:y=y&")":Set b2=SdB.dAtabaSe.QuErysONGS(y):Do While Not b2.eof:cz.ADd b2.Item:b2.Next:Loop:Set b2=Nothing:d8=2+CLng(Timer*10):ap.MaxValUE=cz.Count:For bj=0 To cz.Count-1:Set b0=cz.Item(bj):b0.WriTetAGs:If Abs(d8-CLng(Timer*10))>2 Then sDB.ProCESSMEssAGEs:If ap.teRmiNate Then Exit For:End If:ap.Value=bj+1:ap.TeXT=Sdb.LoCalizE("Writing tags to file")&": "&bj+1&"/"&cz.Count:d8=CLng(Timer*10):End If:Next:End If:If bo And SdB.veRsiONhI>=4 Then SDB.MaiNTREE.REfrESH:End If:If bl Or dm And(af Or c9)Then sdb.mAIntRACKswIndoW.reFrESh:End If:End If:Sdb.cUrSOrTYPe=ee:Set ap=Nothing:sDB.PRoCeSsMesSAgEs:h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:If Len(k)Then k=k&FormatNumber(h,2)&" = "&FormatNumber(df,2):Else k=FormatNumber(h,2):End If:sDB.MeSsaGebOX ak(Len(b9),b9&"."&vbCr,"")&sdB.LOCAlizEDfoRMAT(ak(b6,"Export","Import")&" finished in %s seconds.",CStr(k),0,0),MTiNFormaTioN,Array(Mbok):End Sub:Sub c0(z):ea=z.chECkEd:bx.COMmon.EnaBled=(ea And e5 And Not m):b:End Sub:Sub ef():Dim d1,c,dv,ax,bt,aj,e8,ay,k,y,b8,by,au,a,a8,aw,h,df,bj:cb.coMMOn.enaBLeD=False:dx.cOMMoN.eNabLed=False:cf.cOMMOn.enabLeD=False:d9.coMMOn.ENABled=False:al.COMmoN.EnaBlED=False:dh.cOMmoN.eNAbleD=False:b7.COmmOn.EnAblED=False:ba.COMmOn.eNABLeD=False:a6.coMMOn.EnaBlEd=False:bx.coMMon.enAbled=False:ch.COmmON.enaBLed=False:bb.comMOn.eNAblED=False:bm.comMON.ENABLED=False:dn.ComMon.EnaBleD=False:d2.COMmOn.ENABLEd=False:Set d1=SDB.ObJECts("frmRstrDbase").COMMON:a=an.keys:For bj=0 To an.Count-1:d1.chIldCoNtROl("ctr"&a(bj)).commON.eNAblED=False:Next:Set ap=sdb.PROgREsS:ap.text=sdb.locAlIZe("Comparing databases..."):sDb.procESSmESSageS:ee=SdB.cUrSoRtYPe:sdb.CUrsORtyPe=-19:a7.ENaBlED=False:a8=Now:aw=Timer:df=0:If am Or bi Then p=cw:Else p="":End If:y="SELECT Count(*) FROM BackupDB.Songs":Set c=sdb.DAtabASe.OpensQL(y):ax=CLng(c.ValuebYINDex(0)):If ax Then y="SELECT Max(ID) FROM BackupDB.Songs":Set c=SDb.DATabaSe.OpeNSqL(y):If c.eof Then bt=0:Else If IsNumeric(c.VALUEbYiNdex(0))Then bt=CLng(c.valuEbYinDex(0)):Else bt=0:End If:End If:Else bt=0:End If:y="SELECT Count(*) FROM Songs":Set c=sDB.DATaBAse.opENsql(y):aj=CLng(c.vaLUEbyiNdEX(0)):If aj Then y="SELECT Max(ID) FROM Songs":Set c=SDB.DaTAbase.oPensQl(y):If c.eoF Then e8=0:Else If IsNumeric(c.ValuEbYindeX(0))Then e8=CLng(c.VaLUEByINDeX(0)):Else e8=0:End If:End If:Else e8=0:End If:If bi Then bw=SDb.sEleCtEdsonGliSt.Count:Else If Len(p)Then y="SELECT Count(*) FROM Songs WHERE"&p:Set c=Sdb.dATAbaSe.OpEnSql(y):bw=CLng(c.ValuebyINDEX(0)):Else bw=aj:End If:End If:y="SELECT InfoValue FROM BackupDB.DBInfo WHERE IDInfo = 10":Set c=Sdb.DAtABASE.OPEnSQL(y):dv=CLng(c.VALuebYiNdex(0)):Set c=Nothing:If w And dr=dv And ck=ax And db=aj And bp=bt And av=e8 Then If ab<>am Or b3<>bi Or am And ae<>c1 Then y="UPDATE DBSync SET Selected = ":If(am Or bi)And Len(p)>0 Then y=y&"SongsID IN (SELECT ID FROM Songs WHERE"&p&")":Else y=y&"1":End If:sdB.DAtaBASE.exeCsqL y:y="SELECT Count(*) FROM DBSync":If(am Or bi)And Len(p)>0 Then y=y&" WHERE Selected = 1":End If:Set c=SdB.daTAbaSe.oPEnsQl(y):x=CLng(c.vaLUEbYiNDex(0)):Set c=Nothing:End If:ab=am:b3=bi:aa.CaPtiON=c3&bw&ak(am Or bi,"/"&aj,"")&", "&sDb.LOCaliZe("matched "&be&"s")&": "&x:Sdb.cuRSoRTyPe=ee:b:cb.cOMMOn.ENaBled=True:dx.coMMON.eNabLeD=True:e4:Set ap=Nothing:Exit Sub:Else If Not am And Not bi Or bw=aj Then w=True:d7=a8:Else w=False:End If:du=a5:ab=am:ae=c1:b3=bi:dr=dv:ck=ax:db=aj:bp=bt:av=e8:b9="":End If:x=0:ay=sDB.INIFiLe.iNtVAlUe(t,"ExtraMatchTests"):sdB.DAtABASe.eXECsqL"DROP INDEX IF EXISTS idxMap":sDb.DatAbase.ExEcSqL"DROP TABLE IF EXISTS DBSync":SDb.DaTaBasE.ExECsQl"CREATE TEMP TABLE DBSync (SongsID INTEGER PRIMARY KEY ON CONFLICT IGNORE, BackupID INTEGER UNIQUE ON CONFLICT IGNORE, Selected INTEGER)":SdB.datAbAse.EXeCsQl"CREATE INDEX idxMap ON DBSync (BackupID)":If bw>0 Then y="SELECT InfoValue FROM DBInfo WHERE IDInfo = 10":Set c=sDb.DAtAbasE.OpeNSQL(y):dv=CLng(c.VAluEbYINdeX(0)):Set c=Nothing:If dr=dv Then y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Songs INNER JOIN BackupDB.Songs AS BkpSongs ON Songs.ID = BkpSongs.ID INNER JOIN Medias ON Songs.IDMedia = Medias.IDMedia INNER JOIN BackupDB.Medias AS BckMedias ON BkpSongs.IDMedia = BckMedias.IDMedia AND Songs.SongPath = BkpSongs.SongPath AND (Medias.DriveType = BckMedias.DriveType AND Medias.SerialNumber = BckMedias.SerialNumber OR Medias.DriveLetter = BckMedias.DriveLetter)":If Len(p)Then y=y&" WHERE"&p:End If:y=y&" GROUP BY SongsID ORDER BY SongsID":SDB.dAtABAse.eXEcsql y:Set c=sdB.dATAbaSE.OPensQL("SELECT Count(*) FROM DBSync"):x=CLng(c.VaLuEByiNdex(0)):Set c=Nothing:k=x:End If:If x<bw And x<ck Then If dr=dv Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:b9=b9&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:k=k&" + ":End If:y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Medias INNER JOIN BackupDB.Medias AS BckMedias ON (Medias.DriveType = BckMedias.DriveType AND Medias.SerialNumber = BckMedias.SerialNumber OR Medias.DriveLetter = BckMedias.DriveLetter) INNER JOIN Songs ON Songs.IDMedia = Medias.IDMedia INNER JOIN BackupDB.Songs AS BkpSongs ON BkpSongs.IDMedia = BckMedias.IDMedia AND Songs.SongPath = BkpSongs.SongPath":If dr=dv Then y=y&" WHERE Songs.ID NOT IN (SELECT SongsID FROM DBSync) AND BkpSongs.ID NOT IN (SELECT BackupID FROM DBSync)":If Len(p)Then y=y&" AND"&p:End If:Else If Len(p)Then y=y&" WHERE"&p:End If:End If:y=y&" GROUP BY SongsID":SDB.databASe.ExeCsqL y:Set c=SdB.DatAbaSE.OPensQl("SELECT Count(*) FROM DBSync"):bj=CLng(c.vALuEbyInDEx(0)):Set c=Nothing:k=k&bj-x:x=bj:End If:If x<bw And x<ck And ay>0 Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:b9=b9&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Songs INNER JOIN BackupDB.Songs AS BkpSongs ON Songs.SignPart1 = BkpSongs.SignPart1 AND Songs.SignPart2 = BkpSongs.SignPart2 AND Songs.SignPart3 = BkpSongs.SignPart3 AND Songs.SignPart4 = BkpSongs.SignPart4 WHERE Songs.SignType = 2 AND BkpSongs.SignType = 2 AND Songs.ID NOT IN (SELECT SongsID FROM DBSync) AND BkpSongs.ID NOT IN (SELECT BackupID FROM DBSync)":If Len(p)Then y=y&" AND"&p:End If:y=y&" GROUP BY SongsID HAVING Count(*) = 1":sdB.DatAbAsE.eXECsQl y:Set c=SDB.DAtABasE.oPenSqL("SELECT Count(*) FROM DBSync"):bj=CLng(c.vAlUEbyindeX(0)):Set c=Nothing:k=k&" + "&bj-x:x=bj:If x<bw And x<ck And ay>1 Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:b9=b9&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Albums CROSS JOIN BackupDB.Albums AS BkpAlbums ON Albums.Album = BkpAlbums.Album INNER JOIN Songs ON Songs.IDAlbum = Albums.ID INNER JOIN BackupDB.Songs AS BkpSongs ON BkpAlbums.ID = BkpSongs.IDAlbum AND Songs.FileLength = BkpSongs.FileLength AND Songs.Year = BkpSongs.Year AND Songs.TrackNumber = BkpSongs.TrackNumber AND SubStr(Songs.SongPath, Length(RTrim(Songs.SongPath, Replace(Songs.SongPath, '\', ''))), 9999) = SubStr(BkpSongs.SongPath, Length(RTrim(BkpSongs.SongPath, Replace(BkpSongs.SongPath, '\', ''))), 9999) WHERE Songs.ID NOT IN (SELECT SongsID FROM DBSync) AND BkpSongs.ID NOT IN (SELECT BackupID FROM DBSync)":If Len(p)Then y=y&" AND"&p:End If:y=y&" GROUP BY SongsID HAVING Count(*) = 1":SDB.databaSe.EXEcSqL y:Set c=SdB.DatABASe.oPEnSql("SELECT Count(*) FROM DBSync"):bj=CLng(c.vALueByINdeX(0)):Set c=Nothing:k=k&" + "&bj-x:x=bj:If x<bw And x<ck And ay>2 And 10000*SdB.VErSionhI+100*sDB.verSIOnlO+sDB.VersiOnreleaSE>=30001 Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:b9=b9&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:b8=False:Set c=SDb.DaTAbAsE.OPENSQl("PRAGMA table_info(Songs)"):Do While Not c.eoF:If c.sTringBynaME("name")="Extension"Then b8=True:Exit Do:End If:c.Next:Loop:If b8 Then by="Songs.Extension":Else by="RTrim(Songs.SongPath, Replace(Songs.SongPath, '.', ''))":End If:b8=False:Set c=sDb.daTaBaSe.OpEnsQL("PRAGMA BackupDB.table_info(Songs)"):Do While Not c.EOf:If c.striNgByName("name")="Extension"Then b8=True:Exit Do:End If:c.Next:Loop:Set c=Nothing:If b8 Then au="BkpSongs.Extension":Else au="RTrim(BkpSongs.SongPath, Replace(BkpSongs.SongPath, '.', ''))":End If:y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Folders CROSS JOIN BackupDB.Folders AS BkpFolders ON Folders.Folder = BkpFolders.Folder INNER JOIN Songs ON Songs.IDFolder = Folders.ID INNER JOIN BackupDB.Songs AS BkpSongs ON BkpFolders.ID = BkpSongs.IDFolder AND NullIf(SubStr(LTrim(SubStr(Songs.SongPath, -Length("&by&"), -9999), '\'), InStr(LTrim(Songs.SongPath, '\'), '\') + InStr(SubStr(LTrim(Songs.SongPath, '\'), InStr(LTRim(Songs.SongPath, '\'), '\') + 1, 9999), '\'), 9999), '') = NullIf(SubStr(LTrim(SubStr(BkpSongs.SongPath, -Length("&au&"), -9999), '\'), InStr(LTrim(BkpSongs.SongPath, '\'), '\') + InStr(SubStr(LTrim(BkpSongs.SongPath, '\'), InStr(LTRim(BkpSongs.SongPath, '\'), '\') + 1, 9999), '\'), 9999), '') AND Round(Songs.SongLength / 1000.0) = Round(BkpSongs.SongLength / 1000.0) WHERE Songs.ID NOT IN (SELECT SongsID FROM DBSync) AND BkpSongs.ID NOT IN (SELECT BackupID FROM DBSync)":If Len(p)Then y=y&" AND"&p:End If:y=y&" GROUP BY SongsID HAVING Count(*) = 1":sDb.dATaBASe.ExecSQl y:Set c=sdB.DatAbAsE.OpENsql("SELECT Count(*) FROM DBSync"):bj=CLng(c.ValUEbYiNDeX(0)):Set c=Nothing:k=k&" + "&bj-x:x=bj:If bj<bw And bj<ck And ay>3 Then h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:b9=b9&FormatNumber(h,2)&" + ":a8=Now:aw=Timer:y="INSERT INTO DBSync SELECT Songs.ID AS SongsID, BkpSongs.ID, 1 FROM Albums CROSS JOIN BackupDB.Albums AS BkpAlbums ON Albums.Album = BkpAlbums.Album INNER JOIN Songs ON Songs.IDAlbum = Albums.ID INNER JOIN BackupDB.Songs AS BkpSongs ON BkpAlbums.ID = BkpSongs.IDAlbum WHERE Songs.Year = +BkpSongs.Year AND Albums.Artist = BkpAlbums.Artist AND Songs.TrackNumber = BkpSongs.TrackNumber AND SubStr(SubStr(Songs.SongPath, -Length("&by&"), -9999), Length(RTrim(Songs.SongPath, Replace(Songs.SongPath, '\', ''))), 9999) = SubStr(SubStr(BkpSongs.SongPath, -Length("&au&"), -9999), Length(RTrim(BkpSongs.SongPath, Replace(BkpSongs.SongPath, '\', ''))), 9999) AND Round(Songs.SongLength / 1000.0) = Round(BkpSongs.SongLength / 1000.0) AND Songs.ID NOT IN (SELECT SongsID FROM DBSync) AND BkpSongs.ID NOT IN (SELECT BackupID FROM DBSync)":If Len(p)Then y=y&" AND"&p:End If:y=y&" GROUP BY SongsID HAVING Count(*) = 1":sDB.DataBASe.exECSQL y:Set c=SdB.DaTaBase.OpEnSqL("SELECT Count(*) FROM DBSync"):bj=CLng(c.VAluEByinDeX(0)):Set c=Nothing:k=k&" + "&bj-x:x=bj:End If:End If:End If:End If:End If:If InStr(k," + ")Then k=" ("&k&")":Else k="":End If:If dr=dv Then c3=sdB.LOcAlIZE("Backup db"):Else c3=SDB.LOcalIzE("External db"):End If:If Not m Then y="SELECT group_concat(InfoValue, '.') FROM BackupDB.DBInfo WHERE IDInfo < 3":Set c=SdB.DATAbaSE.opEnsqL(y):c3=c3&" v"&c.StRiNGbyinDEX(0):Set c=Nothing:End If:c3=c3&": "&ck&", "&sDB.LOCAliZE("current db")&": ":aa.CAptIoN=c3&bw&ak(am Or bi,"/"&aj,"")&", "&sdB.locaLIzE("matched "&be&"s")&": "&x&k:sdB.CurSoRtYPe=ee:b:cb.CoMMon.ENablEd=True:dx.coMMOn.enAbleD=True:e4:h=DateDiff("d",a8,Now)*86400+Timer-aw:df=df+h:k=b9&FormatNumber(h,2):If Len(b9)Then k=k&" = "&FormatNumber(df,2):End If:b9=SDB.LOcAlizedfORmAt("Databases compared in %s seconds",CStr(k),0,0):ap.tExt=b9:a7.ENaBled=True:End Sub:Sub bf(z):e7=z.ChECKEd:End Sub:Sub dg(z):Dim d1,a,bj:dm=z.cHeCked:If Not dk Then dn.cOmMon.eNABLED=(Not m And dm):d2.CoMmOn.eNaBleD=(Not m And dm):Set d1=SdB.objecTS("frmRstrDbase").ComMON:a=r.keYs:For bj=0 To r.Count-1:d1.cHILdContROL(a(bj)).COMmON.enABled=(Not m And dm):Next:b:End If:End Sub:Sub dq(z):On Error Resume Next:CreateObject("WScript.Shell").RUN(a0):On Error GoTo 0:End Sub:Function q(y,v,n,ct,bs):Dim cn,bd,c,br,a4,co,e3,bj,ce:q=y:Set cn=New RegExp:cn.IgnoreCase=True:cn.Global=True:cn.mULTIliNe=True:cn.Pattern="(^\[AdvCond\d+?\]$(?:[^[]|(?:\r\n))+?^DBField ?= ?Genres\.GenreName$(?:[^[]|(?:\r\n))+?^Condition ?= ?30[1-2]$(?:[^[]|(?:\r\n))+?^Value ?= ?)(\d+?(?:,\d+?)*?)$":If cn.Test(y)Then Set bd=cn.Execute(y):q=cn.Replace(q,"$1"&Chr(0)):For bj=0 To bd.Count-1:Set c=sDB.DAtabaSe.OPEnSqL("SELECT group_concat(DstGenres.IDGenre) FROM "&v&"Genres AS SrcGenres INNER JOIN "&n&"Genres AS DstGenres ON SrcGenres.GenreName = DstGenres.GenreName AND SrcGenres.IDGenre IN ("&bd.Item(bj).SubMatches.Item(1)&")"):If Not c.eoF Then q=Replace(q,Chr(0),c.strinGbyiNDEx(0),1,1):Else q=Replace(q,Chr(0),"0",1,1):End If:Set c=Nothing:Next:End If:cn.Pattern="(^\[AdvCond\d+?\]$(?:[^[]|(?:\r\n))+?^DBField ?= ?)(Tempo|Mood|Occasion|Quality)($(?:[^[]|(?:\r\n))+?^Condition ?= ?300$(?:[^[]|(?:\r\n))+?^Value ?= ?)(\d+?(?:,\d+?)*?)$":If cn.Test(q)Then Set bd=cn.Execute(q):q=cn.Replace(q,"$1$2$3"&Chr(0)):Select Case LCase(bd.Item(0).SubMatches.Item(1)):Case"tempo":e3=1:Case"mood":e3=2:Case"occasion":e3=3:Case"quality":e3=4:Case Else e3=0:End Select:For bj=0 To bd.Count-1:Set c=SdB.DATABAse.oPENsQl("SELECT group_concat(DstLists.ID) FROM "&v&"Lists AS SrcLists INNER JOIN "&n&"Lists AS DstLists ON SrcLists.TextData = DstLists.TextData WHERE SrcLists.IDListType = "&e3&" AND DstLists.IDListType = "&e3&" AND SrcLists.ID IN ("&bd.Item(bj).SubMatches.Item(3)&")"):If Not c.eof Then q=Replace(q,Chr(0),c.stRINGbYIndex(0),1,1):Else q=Replace(q,Chr(0),"0",1,1):End If:Set c=Nothing:Next:End If:cn.Pattern="(^\[AdvCond\d+?\]$(?:[^[]|(?:\r\n))+?^DBField ?= ?(?:=Artists\.Artist|Songs\.AlbumArtist)$(?:[^[]|(?:\r\n))+?^Condition ?= ?30[1-2]$(?:[^[]|(?:\r\n))+?^Value ?= ?)(\d+?(?:,\d+?)*?)$":If cn.Test(y)Then Set bd=cn.Execute(y):q=cn.Replace(q,"$1"&Chr(0)):For bj=0 To bd.Count-1:Set c=SDb.DatabAsE.OpeNSQL("SELECT group_concat(DstArtists.ID) FROM "&v&"Artists AS SrcArtists INNER JOIN "&n&"Artists AS DstArtists ON SrcArtists.Artist = DstArtists.Artist AND SrcArtists.ID IN ("&bd.Item(bj).SubMatches.Item(1)&")"):If Not c.eoF Then q=Replace(q,Chr(0),c.StRiNGBYinDex(0),1,1):Else q=Replace(q,Chr(0),"0",1,1):End If:Set c=Nothing:Next:End If:cn.Pattern="(^\[AdvCond\d+?\]$(?:[^[]|(?:\r\n))+?^DBField ?= ?Songs\.Album$(?:[^[]|(?:\r\n))+?^Condition ?= ?30[1-2]$(?:[^[]|(?:\r\n))+?^Value ?= ?)(\d+?(?:,\d+?)*?)$":If cn.Test(y)Then Set bd=cn.Execute(y):q=cn.Replace(q,"$1"&Chr(0)):For bj=0 To bd.Count-1:Set c=sdB.DATaBasE.OPEnSql("SELECT group_concat(DstAlbums.ID) FROM "&v&"Albums AS SrcAlbums INNER JOIN "&n&"Albums AS DstAlbums ON SrcAlbums.Album = DstAlbums.Album AND SrcAlbums.Artist = DstAlbums.Artist AND SrcAlbums.ID IN ("&bd.Item(bj).SubMatches.Item(1)&")"):If Not c.eOf Then q=Replace(q,Chr(0),c.stRIngByindex(0),1,1):Else q=Replace(q,Chr(0),"0",1,1):End If:Set c=Nothing:Next:End If:If Not ct Is Nothing Then cn.Pattern="(^\[AdvCond\d+?\]$(?:[^[]|(?:\r\n))+?^DBField ?= ?$(?:[^[]|(?:\r\n))+?^Condition ?= ?(?:10)?601$(?:[^[]|(?:\r\n))+?^Value ?= ?)(\d+?(?:,\d+?)*?)$":If cn.Test(y)Then Set bd=cn.Execute(y):q=cn.Replace(q,"$1"&Chr(0)):For bj=0 To bd.Count-1:a4="":br=Split(bd.Item(bj).SubMatches.Item(1),","):For ce=0 To UBound(br):If bs.exIStS(CStr(br(ce)))Then co=bs.Item(CStr(br(ce))):If ct.exIstS(co)Then a4=a4&ct.Item(co)&",":End If:End If:Next:If Len(a4)Then q=Replace(q,Chr(0),Left(a4,Len(a4)-1),1,1):Else q=Replace(q,Chr(0),"0",1,1):End If:Next:End If:End If:End Function:Sub az(z):af=z.CHeCKEd:If Not dk Then b:End If:End Sub:Sub b5(z):bo=z.CHECkeD:bb.CoMmon.ENAblED=bo:If Not dk Then b:End If:End Sub:Sub b4(z):Dim a3,c5,cv,c6,cp:a5=z.Text:If dk Then Exit Sub:End If:With z.comMON.parent.COMmOn:Set a3=.cHilDCONtrol("btn_Backup"):Set c5=.CHILDconTROl("btn_Export"):Set cv=.childcOnTROL("btn_Import"):End With:If UCase(a5)=UCase(sDb.DATAbAsE.PaTh)Then aa.caPTioN=SdB.lOCALIzE("You have specified the current database instead of the backup file!"):cp=True:Else aa.CApTIOn=SdB.lOCAlIZE("Loading database"&cy):cp=False:End If:sdb.prOCEsSMeSsAgES:If cp Then c6=False:Else If sdb.TOols.FileSystem.FilEexISts(a5)Then c6=True:Else c6=False:End If:End If:If Len(a5)>0 And Not cp Then a3.ComMoN.ENABLEd=True:Else a3.COMmOn.enABlED=False:End If:On Error Resume Next:If ds Then ds=False:SDb.DAtABaSE.exEcsQl"DETACH DATABASE BackupDB":End If:If c6 And Err=0 Then SdB.DAtaBaSe.FOrCEcOmMit:sdB.dAtAbASE.exeCSql"ATTACH DATABASE '"&cq(a5)&"' AS BackupDB":If Err=0 Then ds=True:End If:End If:If Err<>0 Or Not c6 Then If cp Then:Else If Len(a5)=0 Then aa.capTiON=sDb.loCaLIzE("Please specify database file for backup/export/import."):Else If Not c6 Then aa.CAPTIoN=SdB.LocaliZE("Database file doesn't exist."):Else aa.CaPTION=SdB.lOCALize("Wrong backup database file!"):End If:End If:End If:c5.cOMmON.ENABled=False:cv.cOmmoN.enabLeD=False:ds=False:Exit Sub:End If:On Error GoTo 0:m=False:If SDb.DaTABasE.opEnsql("SELECT Count(*) FROM BackupDB.sqlite_master WHERE name = 'PlaylistSongs'").vALUebYindEX(0)=0 Then If SDB.dAtAbaSe.oPenSQL("SELECT Count(*) FROM BackupDB.sqlite_master WHERE name = 'Playlists'").VAluEBYindEX(0)=0 Then aa.CAPTiON=sdb.lOcaLiZE("Wrong backup database file!"):ds=False:On Error Resume Next:sdB.daTABAse.execsqL"DETACH DATABASE BackupDB":On Error GoTo 0:Else m=True:aa.CaPtIOn=SDB.LocALIZE("Backup database contains only auto-playlists data"):End If:b:e4:Else b:ef:End If:End Sub:Sub ci(z):e5=z.cHecked:bx.cOMMoN.enabLed=(ea And e5 And Not m):b:End Sub:Sub e4():Dim d1,a,bj:al.CoMmOn.ENablED=Not m:cf.commOn.eNabLEd=Not m:d9.cOMMOn.EnaBlEd=(Not m And am):dh.cOmMoN.ENAbleD=Not m:b7.COMMon.eNAbLEd=(Not m And bl):ba.cOmmoN.enAbLeD=Not m:a6.CommON.EnAbLed=True:bx.COMMON.ENABLED=(Not m And ea And e5):ch.ComMon.enablEd=Not m:bb.COMMoN.enABlEd=(Not m And bo):bm.COmmOn.enaBLED=Not m:dn.cOmMON.EnABleD=(Not m And dm):d2.cOMmON.ENabLED=(Not m And dm):Set d1=sdB.ObjeCTS("frmRstrDbase").COmMoN:a=r.kEYs:For bj=0 To r.Count-1:d1.chILDcoNtROL(a(bj)).ComMon.enaBlED=(Not m And dm):Next:End Sub:Function ak(cr,dy,bg):If cr Then ak=dy:Else ak=bg:End If:End Function:Sub ed(bq,ds):If ds Then ds=False:On Error Resume Next:sdb.dATaBAse.ExEcsQL"DETACH DATABASE BackupDB":On Error GoTo 0:End If:sdB.DaTaBASe.exeCsQl"PRAGMA temp_store="&bq:End Sub:Sub a2(a7):a7.ENabLED=False:Set ap=Nothing:End Sub